using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Activities;
using T2.WebSecurity.Business;
using T2.WebSecurity.Business.Entities.Interfaces;
using T2.WebSecurity.Business.Entities;

namespace T2.WebSecurity.Business.Workflow.Activites
{
	public sealed class Db_T2_WebSecurity_UserProfile_Modify : CodeActivity
	{
		private IBusinessService bs = null;
		public OutArgument<IDictionary<string, int>> RetVal { get; set; }
		public InArgument<IBusinessService> BS {get;set;}
		public InArgument<IUserProfile_biz> ModifyParam { get; set; }
		private IUserProfile_biz modifyParam ;
        IDictionary<string, int> tempReturn;

		protected override void Execute(CodeActivityContext context)
		{
			bs = context.GetValue(BS);
            modifyParam = context.GetValue(ModifyParam);
            if (modifyParam != null)
            {
                modifyParam.Action = "Update";
                modifyParam.Address = modifyParam.Address;
                modifyParam.CellPhone = modifyParam.CellPhone;
                modifyParam.City = modifyParam.City;
                modifyParam.FirstName = modifyParam.FirstName;
                modifyParam.IsActive = modifyParam.IsActive;
                modifyParam.LastName = modifyParam.LastName;
                modifyParam.ModifiedBy = modifyParam.ModifiedBy;
                modifyParam.ModifiedDt = modifyParam.ModifiedDt;
                modifyParam.OfficePhone = modifyParam.OfficePhone;
                modifyParam.PostalCode = modifyParam.PostalCode;
                modifyParam.Region = modifyParam.Region;
                modifyParam.Title = modifyParam.Title;

                tempReturn = bs.UserProfileController_Set(modifyParam);

                Int32 RA = GetValueFromDictionary("Rows_Affected", tempReturn);
                Int32 RV = GetValueFromDictionary("Return_Value", tempReturn);
                if (RA + RV == 0)
                {
                    throw new ApplicationException("You tried to overwrite the same record as another individual");
                }
                else
                {
                    context.SetValue(RetVal, tempReturn);
                }
            }
		}

        private Int32 GetValueFromDictionary(string Key, IDictionary<string, Int32> MyDictionary)
        {

            Int32 RetVal = MyDictionary.Where(z => z.Key == Key).Select(p => p.Value).FirstOrDefault();
            return RetVal;
        }
	}
}
