using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using T2.WebSecurity.Data.Controllers.Interfaces;
using T2.WebSecurity.Data.Entities.Interfaces;
using T2.WebSecurity.Business.Entities.Interfaces;
using T2.WebSecurity.Business.Entities;
using T2.WebSecurity.Business.Builders;
using T2.WebSecurity.Business.Directors.Interface;
using T2.WebSecurity.Business.Entities.Search.Interfaces;

//--Change Management Control - ApplicationUser Director  --**********************
//--Created By: trooks
//--Description: ApplicationUser Director Class
//--Created Date: 03/07/2013 10:49:11
//--*************************************************************

namespace T2.WebSecurity.Business.Directors
{
	public partial class ApplicationUser_Director_biz : IApplicationUser_director_biz
	{
		
		public List<IApplicationUser_biz> Construct (IApplicationUser_biz _param, bool BuildUp, bool BuildDown)
		{
			ApplicationUser_Builder build = new ApplicationUser_Builder();
			List<IApplicationUser_biz> retVal = build.BuildParts(_param);
			foreach(IApplicationUser_biz item in retVal)
			{
				item.UserProfile = BuildUserProfile(item, BuildUp, false);
				item.Application = BuildApplication(item, BuildUp, false);
		}
			return retVal;
		}
		public List<IApplicationUser_biz> Construct (IApplicationUserSearch_biz _param, bool BuildUp, bool BuildDown)
		{
			ApplicationUser_Builder build = new ApplicationUser_Builder();
			List<IApplicationUser_biz> retVal = build.BuildParts(_param);
			foreach(IApplicationUser_biz item in retVal)
			{
				item.UserProfile = BuildUserProfile(item, BuildUp, false);
				item.Application = BuildApplication(item, BuildUp, false);
		}
			return retVal;
		}
		private IUserProfile_biz BuildUserProfile(IApplicationUser_biz _param, bool BuildUp, bool BuildDown)
		{
			IUserProfile_biz retVal = new UserProfile_biz();
			if(BuildUp)
			{
			IUserProfile_biz UserProfileParam = new UserProfile_biz();
			UserProfileParam.Action = "GetOne";
			UserProfileParam.UserId = _param.UserId;
			UserProfile_Builder builder = new UserProfile_Builder();
			retVal = builder.BuildParts(UserProfileParam).First();
			}
			return retVal;
		}
		private IApplication_biz BuildApplication(IApplicationUser_biz _param, bool BuildUp, bool BuildDown)
		{
			IApplication_biz retVal = new Application_biz();
			if(BuildUp)
			{
			IApplication_biz ApplicationParam = new Application_biz();
			ApplicationParam.Action = "GetOne";
			ApplicationParam.ApplicationID = _param.ApplicationID;
			Application_Builder builder = new Application_Builder();
			retVal = builder.BuildParts(ApplicationParam).First();
			}
			return retVal;
		}
	}
}