using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using System.Data;
using System.Configuration;
using System.Data.SqlClient;
using T2.WebSecurity.Data.Entities;
using T2.WebSecurity.Data.Entities.Interfaces;
using T2.WebSecurity.Data.Controllers.Interfaces;
using T2.WebSecurity.Data.Entities.Search.Interfaces;
using T2.WebSecurity.Data.Entities.Search;

namespace T2.WebSecurity.Data.Controllers
{
	public partial class ApplicationController : IApplicationController
	{
	private IApplication TranslateApplicationFromDb(DataRow  _translateFrom)
	{
		IApplication temp = new Application();
		temp.Action = T2.WebSecurity.Common.MyEnum.Actions.None.ToString();
		if(_translateFrom["ApplicationID"] != null && _translateFrom["ApplicationID"].ToString().Length > 0)
		{
		temp.ApplicationID = Convert.ToInt32(_translateFrom["ApplicationID"]);
		}
		else
		{
		temp.ApplicationID = Convert.ToInt32("-1");
		}
		if(_translateFrom["ApplicationName"] != null && _translateFrom["ApplicationName"].ToString().Length > 0)
		{
		temp.ApplicationName = Convert.ToString(_translateFrom["ApplicationName"]);
		}
		else
		{
		temp.ApplicationName = String.Empty;
		}
		temp.TS = (Byte[])_translateFrom["TS"];
		if(_translateFrom["CreatedBy"] != null && _translateFrom["CreatedBy"].ToString().Length > 0)
		{
		temp.CreatedBy = Convert.ToString(_translateFrom["CreatedBy"]);
		}
		else
		{
		temp.CreatedBy = String.Empty;
		}
		if(_translateFrom["CreatedDt"] != null && _translateFrom["CreatedDt"].ToString().Length > 0)
		{
		temp.CreatedDt = Convert.ToDateTime(_translateFrom["CreatedDt"]);
		}
		else
		{
		temp.CreatedDt = Convert.ToDateTime("01/01/1753");
		}
		if(_translateFrom["ModifiedBy"] != null && _translateFrom["ModifiedBy"].ToString().Length > 0)
		{
		temp.ModifiedBy = Convert.ToString(_translateFrom["ModifiedBy"]);
		}
		else
		{
		temp.ModifiedBy = String.Empty;
		}
		if(_translateFrom["ModifiedDt"] != null && _translateFrom["ModifiedDt"].ToString().Length > 0)
		{
		temp.ModifiedDt = Convert.ToDateTime(_translateFrom["ModifiedDt"]);
		}
		else
		{
		temp.ModifiedDt = Convert.ToDateTime("01/01/1753");
		}
		return temp;
	}
	private IApplication TranslateSearchApplicationFromDb(DataRow  _translateFrom)
	{
		IApplication temp = new Application();
		temp.Action = T2.WebSecurity.Common.MyEnum.Actions.None.ToString();
		if(_translateFrom["ApplicationName"] != null && _translateFrom["ApplicationName"].ToString().Length > 0)
		{
		temp.ApplicationName = Convert.ToString(_translateFrom["ApplicationName"]);
		}
		else
		{
		temp.ApplicationName = String.Empty;
		}
		return temp;
	}
		public IDictionary<string,Int32> Application_Add(IApplication  _application)
		{
			IDictionary<string, int> RetDict = new Dictionary<string, int>();
			string connect = ConfigurationManager.ConnectionStrings["WebSecurity"].ToString();
			SqlConnection db = new SqlConnection(connect);
			SqlCommand cmd = new SqlCommand("Application_ins", db);
			cmd.CommandType = CommandType.StoredProcedure;
			cmd.Connection.Open();
			try
			{
			SqlParameter sp_ApplicationID = DataHelpers.GetParameter("ApplicationID", SqlDbType.Int, ParameterDirection.Output, 4) ;
			sp_ApplicationID.Value = _application.ApplicationID;
			cmd.Parameters.Add(sp_ApplicationID);

			SqlParameter sp_ApplicationName = DataHelpers.GetParameter("ApplicationName", SqlDbType.NVarChar, ParameterDirection.Input, 100) ;
			sp_ApplicationName.Value = _application.ApplicationName;
			cmd.Parameters.Add(sp_ApplicationName);

			SqlParameter sp_CreatedBy = DataHelpers.GetParameter("CreatedBy", SqlDbType.VarChar, ParameterDirection.Input, 50) ;
			sp_CreatedBy.Value = _application.CreatedBy;
			cmd.Parameters.Add(sp_CreatedBy);

			SqlParameter sp_CreatedDt = DataHelpers.GetParameter("CreatedDt", SqlDbType.DateTime, ParameterDirection.Input, 13) ;
			sp_CreatedDt.Value = _application.CreatedDt;
			cmd.Parameters.Add(sp_CreatedDt);

			SqlParameter sp_ModifiedBy = DataHelpers.GetParameter("ModifiedBy", SqlDbType.VarChar, ParameterDirection.Input, 50) ;
			sp_ModifiedBy.Value = _application.ModifiedBy;
			cmd.Parameters.Add(sp_ModifiedBy);

			SqlParameter sp_ModifiedDt = DataHelpers.GetParameter("ModifiedDt", SqlDbType.DateTime, ParameterDirection.Input, 13) ;
			sp_ModifiedDt.Value = _application.ModifiedDt;
			cmd.Parameters.Add(sp_ModifiedDt);

			SqlParameter sp_RowsAffected = DataHelpers.GetParameter("RowsAffected", SqlDbType.Int, ParameterDirection.Output, 4) ;
			cmd.Parameters.Add(sp_RowsAffected);

			int RetVal = cmd.ExecuteNonQuery();
			KeyValuePair<string, int> KVPRetVal = new KeyValuePair<string, int>("Return_Value", RetVal);
			RetDict.Add(KVPRetVal);
			int Affected = Convert.ToInt32(sp_RowsAffected.Value);
			KeyValuePair<string, int> RARetVal = new KeyValuePair<string, int>("Rows_Affected", Affected);
			RetDict.Add(RARetVal);
			int PkApplicationID = Convert.ToInt32(sp_ApplicationID.Value);
			KeyValuePair<string, int> PKApplicationID = new KeyValuePair<string, int>("PKApplicationID", PkApplicationID);
			RetDict.Add(PKApplicationID);
			return RetDict;
			}
			catch(Exception ex)
			{
			throw ex;
			}
			finally
			{
			if (cmd != null)
			{
			cmd.Connection.Close();
			cmd.Dispose();
			}
			}
		}
		public IDictionary<string,Int32> Application_Modify(IApplication  _application)
		{
			IDictionary<string, int> RetDict = new Dictionary<string, int>();
			string connect = ConfigurationManager.ConnectionStrings["WebSecurity"].ToString();
			SqlConnection db = new SqlConnection(connect);
			SqlCommand cmd = new SqlCommand("Application_udt", db);
			cmd.CommandType = CommandType.StoredProcedure;
			cmd.Connection.Open();
			try
			{
			SqlParameter sp_ApplicationID = DataHelpers.GetParameter("ApplicationID", SqlDbType.Int, ParameterDirection.Input, 4) ;
			sp_ApplicationID.Value = _application.ApplicationID;
			cmd.Parameters.Add(sp_ApplicationID);

			SqlParameter sp_ApplicationName = DataHelpers.GetParameter("ApplicationName", SqlDbType.NVarChar, ParameterDirection.Input, 100) ;
			sp_ApplicationName.Value = _application.ApplicationName;
			cmd.Parameters.Add(sp_ApplicationName);

			SqlParameter sp_TS = DataHelpers.GetParameter("TS", SqlDbType.Timestamp, ParameterDirection.Input, 8) ;
			sp_TS.Value = _application.TS;
			cmd.Parameters.Add(sp_TS);

			SqlParameter sp_CreatedBy = DataHelpers.GetParameter("CreatedBy", SqlDbType.VarChar, ParameterDirection.Input, 50) ;
			sp_CreatedBy.Value = _application.CreatedBy;
			cmd.Parameters.Add(sp_CreatedBy);

			SqlParameter sp_CreatedDt = DataHelpers.GetParameter("CreatedDt", SqlDbType.DateTime, ParameterDirection.Input, 13) ;
			sp_CreatedDt.Value = _application.CreatedDt;
			cmd.Parameters.Add(sp_CreatedDt);

			SqlParameter sp_ModifiedBy = DataHelpers.GetParameter("ModifiedBy", SqlDbType.VarChar, ParameterDirection.Input, 50) ;
			sp_ModifiedBy.Value = _application.ModifiedBy;
			cmd.Parameters.Add(sp_ModifiedBy);

			SqlParameter sp_ModifiedDt = DataHelpers.GetParameter("ModifiedDt", SqlDbType.DateTime, ParameterDirection.Input, 13) ;
			sp_ModifiedDt.Value = _application.ModifiedDt;
			cmd.Parameters.Add(sp_ModifiedDt);

			SqlParameter sp_RowsAffected = DataHelpers.GetParameter("RowsAffected", SqlDbType.Int, ParameterDirection.Output, 4) ;
			cmd.Parameters.Add(sp_RowsAffected);
			int RetVal = cmd.ExecuteNonQuery();
			KeyValuePair<string, int> KVPRetVal = new KeyValuePair<string, int>("Return_Value", RetVal);
			RetDict.Add(KVPRetVal);
			int Affected = Convert.ToInt32(sp_RowsAffected.Value);
			KeyValuePair<string, int> RARetVal = new KeyValuePair<string, int>("Rows_Affected", Affected);
			RetDict.Add(RARetVal);
			int PkApplicationID = Convert.ToInt32(sp_ApplicationID.Value);
			KeyValuePair<string, int> PKApplicationID = new KeyValuePair<string, int>("PKApplicationID", PkApplicationID);
			RetDict.Add(PKApplicationID);
			return RetDict;
			}
			catch(Exception ex)
			{
			throw ex;
			}
			finally
			{
			if (cmd != null)
			{
			cmd.Connection.Close();
			cmd.Dispose();
			}
			}
		}
		public IDictionary<string, int> Application_Remove(IApplication  _application)
		{
			IDictionary<string, int> RetDict = new Dictionary<string, int>();
			string connect = ConfigurationManager.ConnectionStrings["WebSecurity"].ToString();
			SqlConnection db = new SqlConnection(connect);
			SqlCommand cmd = new SqlCommand("Application_del", db);
			cmd.CommandType = CommandType.StoredProcedure;
			cmd.Connection.Open();
			try
			{
			SqlParameter sp_ApplicationID = DataHelpers.GetParameter("ApplicationID", SqlDbType.Int, ParameterDirection.Input, 4) ;
			sp_ApplicationID.Value = _application.ApplicationID;
			cmd.Parameters.Add(sp_ApplicationID);

			SqlParameter sp_TS = DataHelpers.GetParameter("TS", SqlDbType.Timestamp, ParameterDirection.Input, 8) ;
			sp_TS.Value = _application.TS;
			cmd.Parameters.Add(sp_TS);

			SqlParameter sp_RowsAffected = DataHelpers.GetParameter("RowsAffected", SqlDbType.Int, ParameterDirection.Output, 4) ;
			cmd.Parameters.Add(sp_RowsAffected);
			int RetVal = cmd.ExecuteNonQuery();
			KeyValuePair<string, int> KVPRetVal = new KeyValuePair<string, int>("Return_Value", RetVal);
			RetDict.Add(KVPRetVal);
			int Affected = Convert.ToInt32(sp_RowsAffected.Value);
			KeyValuePair<string, int> RARetVal = new KeyValuePair<string, int>("Rows_Affected", Affected);
			RetDict.Add(RARetVal);
			return RetDict;
			}
			catch(Exception ex)
			{
			throw ex;
			}
			finally
			{
			if (cmd != null)
			{
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
			}
			}
		}
		public IApplication Application_GetOne(IApplication  _application)
		{
			string connect = ConfigurationManager.ConnectionStrings["WebSecurity"].ToString();
			SqlConnection db = new SqlConnection(connect);
			SqlCommand cmd = new SqlCommand("Application_GetOne", db);
			cmd.CommandType = CommandType.StoredProcedure;
			cmd.Connection.Open();
			try
			{
			SqlParameter sp_ApplicationID = DataHelpers.GetParameter("ApplicationID", SqlDbType.Int, ParameterDirection.Input, 4) ;
			sp_ApplicationID.Value = _application.ApplicationID;
			cmd.Parameters.Add(sp_ApplicationID);

			SqlParameter sp_RowsAffected = DataHelpers.GetParameter("RowsAffected", SqlDbType.Int, ParameterDirection.Output, 4) ;
			cmd.Parameters.Add(sp_RowsAffected);
			DataSet ds = new DataSet();
			SqlDataAdapter da = new SqlDataAdapter(cmd);
			da.Fill(ds);
			int Affected = Convert.ToInt32(sp_RowsAffected.Value);
			IApplication RetVal = new Application();
			if (ds.Tables.Count > 0 && ds.Tables[0].Rows.Count > 0)
			{
			RetVal = TranslateApplicationFromDb(ds.Tables[0].Rows[0]);
			RetVal.TotalRows = Affected;
			}
			return RetVal;
			}
			catch(Exception ex)
			{
			throw ex;
			}
			finally
			{
			if (cmd != null)
			{
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
			}
			}
		}
		public List<IApplication> Application_GetAll(IApplication  _application)
		{
			string connect = ConfigurationManager.ConnectionStrings["WebSecurity"].ToString();
			SqlConnection db = new SqlConnection(connect);
			SqlCommand cmd = new SqlCommand("Application_GetAll", db);
			cmd.CommandType = CommandType.StoredProcedure;
			cmd.Connection.Open();
			try
			{
			SqlParameter sp_PageSize = DataHelpers.GetParameter("PageSize", SqlDbType.Int, ParameterDirection.Input, 4) ;
			sp_PageSize.Value = _application.PageSize;
			cmd.Parameters.Add(sp_PageSize);
			SqlParameter sp_PageNumber = DataHelpers.GetParameter("PageNumber", SqlDbType.Int, ParameterDirection.Input, 4) ;
			sp_PageNumber.Value = _application.PageNumber;
			cmd.Parameters.Add(sp_PageNumber);
			SqlParameter sp_SortColumn = DataHelpers.GetParameter("SortColumn", SqlDbType.NVarChar, ParameterDirection.Input, 50) ;
			sp_SortColumn.Value = _application.SortColumn;
			cmd.Parameters.Add(sp_SortColumn);
			SqlParameter sp_SortType = DataHelpers.GetParameter("SortType", SqlDbType.NVarChar, ParameterDirection.Input, 10) ;
			sp_SortType.Value = _application.SortType;
			cmd.Parameters.Add(sp_SortType);
			SqlParameter sp_TotalRows = DataHelpers.GetParameter("TotalRows", SqlDbType.Int, ParameterDirection.Output, 4) ;
			cmd.Parameters.Add(sp_TotalRows);
			SqlParameter sp_RowsAffected = DataHelpers.GetParameter("RowsAffected", SqlDbType.Int, ParameterDirection.Output, 4) ;
			cmd.Parameters.Add(sp_RowsAffected);
			DataSet ds = new DataSet();
			SqlDataAdapter da = new SqlDataAdapter(cmd);
			da.Fill(ds);
			int Affected = Convert.ToInt32(sp_RowsAffected.Value);
			List<IApplication> tempList = new List<IApplication>();
			
			foreach(DataTable tb in ds.Tables)
			{
				foreach(DataRow r in tb.Rows)
				{
                    IApplication temp = TranslateApplicationFromDb(r);
					temp.TotalRows = Convert.ToInt32(sp_TotalRows.Value);
					tempList.Add(temp);
				}
			}
			return tempList;
			}
			catch(Exception ex)
			{
			throw ex;
			}
			finally
			{
			if (cmd != null)
			{
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
			}
			}
		}
		public List<IApplication> Application_Search(IApplicationSearch _application)
		{
			string connect = ConfigurationManager.ConnectionStrings["WebSecurity"].ToString();
			SqlConnection db = new SqlConnection(connect);
			SqlCommand cmd = new SqlCommand("Application_Search", db);
			cmd.CommandType = CommandType.StoredProcedure;
			cmd.Connection.Open();
			try
			{
			SqlParameter sp_ApplicationName = DataHelpers.GetParameter("ApplicationName", SqlDbType.NVarChar, ParameterDirection.Input, 100) ;
			sp_ApplicationName.Value = _application.ApplicationName;
			cmd.Parameters.Add(sp_ApplicationName);

			SqlParameter sp_PageSize = DataHelpers.GetParameter("PageSize", SqlDbType.Int, ParameterDirection.Input, 4) ;
			sp_PageSize.Value = _application.PageSize;
			cmd.Parameters.Add(sp_PageSize);
			SqlParameter sp_PageNumber = DataHelpers.GetParameter("PageNumber", SqlDbType.Int, ParameterDirection.Input, 4) ;
			sp_PageNumber.Value = _application.PageNumber;
			cmd.Parameters.Add(sp_PageNumber);
			SqlParameter sp_SortColumn = DataHelpers.GetParameter("SortColumn", SqlDbType.NVarChar, ParameterDirection.Input, 50) ;
			sp_SortColumn.Value = _application.SortColumn;
			cmd.Parameters.Add(sp_SortColumn);
			SqlParameter sp_SortType = DataHelpers.GetParameter("SortType", SqlDbType.NVarChar, ParameterDirection.Input, 10) ;
			sp_SortType.Value = _application.SortType;
			cmd.Parameters.Add(sp_SortType);
			SqlParameter sp_TotalRows = DataHelpers.GetParameter("TotalRows", SqlDbType.Int, ParameterDirection.Output, 4) ;
			cmd.Parameters.Add(sp_TotalRows);
			SqlParameter sp_RowsAffected = DataHelpers.GetParameter("RowsAffected", SqlDbType.Int, ParameterDirection.Output, 4) ;
			cmd.Parameters.Add(sp_RowsAffected);
			DataSet ds = new DataSet();
			SqlDataAdapter da = new SqlDataAdapter(cmd);
			da.Fill(ds);
			int Affected = Convert.ToInt32(sp_RowsAffected.Value);
			List<IApplication> tempList = new List<IApplication>();
			foreach(DataTable tb in ds.Tables)
			{
				foreach(DataRow r in tb.Rows)
				{
					IApplication temp = new Application();
					temp = TranslateApplicationFromDb(r);
					tempList.Add(temp);
				}
			}
			return tempList;
			}
			catch(Exception ex)
			{
			throw ex;
			}
			finally
			{
			if (cmd != null)
			{
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
			}
			}
		}

    }
}
