using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using System.Data;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Microsoft.Practices.EnterpriseLibrary.Data;

namespace WebSecurity.Database.Test
{
 [TestClass]
    public class SearchUnitTests
    {
        public SearchUnitTests()
        {
           

           
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }
		
		#region Additional test attributes

        #endregion
		#region Test Methods

        
		[TestMethod]
        public void UserProfile_SearchTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");
            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("UserProfile_Search");
			
			db.AddInParameter(cmd, "PageSize", System.Data.DbType.Int32, 10);
			db.AddInParameter(cmd, "PageNumber", System.Data.DbType.Int32, 1);
			db.AddInParameter(cmd, "SortColumn", System.Data.DbType.String, "UserId");
			db.AddInParameter(cmd, "SortType", System.Data.DbType.String, "asc");
			db.AddInParameter(cmd,"UserName", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"CreatedBy", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_CreatedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_CreatedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"ModifiedBy", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_ModifiedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_ModifiedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"FirstName", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"LastName", System.Data.DbType.String, "Sample");
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.IsTrue(Affected > 0, "dbo_UserProfile Search Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
			
			
			
			
		}
		
		
				[TestMethod]
        public void Membership_SearchTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");
            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("Membership_Search");
			
			db.AddInParameter(cmd, "PageSize", System.Data.DbType.Int32, 10);
			db.AddInParameter(cmd, "PageNumber", System.Data.DbType.Int32, 1);
			db.AddInParameter(cmd, "SortColumn", System.Data.DbType.String, "MembershipID");
			db.AddInParameter(cmd, "SortType", System.Data.DbType.String, "asc");
			db.AddInParameter(cmd,"ConfirmationToken", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_LastPasswordFailureDate", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_LastPasswordFailureDate", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"Beg_PasswordFailuresSinceLastSuccess", System.Data.DbType.Int32, 1);
			db.AddInParameter(cmd,"End_PasswordFailuresSinceLastSuccess", System.Data.DbType.Int32, 1);
			db.AddInParameter(cmd,"Password", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_PasswordChangedDate", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_PasswordChangedDate", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"PasswordSalt", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"PasswordVerificationToken", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_PasswordVerificationTokenExpirationDate", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_PasswordVerificationTokenExpirationDate", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"CreatedBy", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_CreatedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_CreatedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"ModifiedBy", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_ModifiedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_ModifiedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"EmailAccount", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"PasswordAnswer", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_LastLoginDate", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_LastLoginDate", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"Beg_LastLockoutDate", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_LastLockoutDate", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"Beg_UserId", System.Data.DbType.Int32, GetFirstForeignKey("UserProfile_GetAll", "UserId"));
			db.AddInParameter(cmd,"End_UserId", System.Data.DbType.Int32, GetLastForeignKey("UserProfile_GetAll", "UserId"));
			db.AddInParameter(cmd,"Beg_PasswordQuestionID", System.Data.DbType.Int32, GetFirstForeignKey("PasswordQuestion_GetAll", "PasswordQuestionID"));
			db.AddInParameter(cmd,"End_PasswordQuestionID", System.Data.DbType.Int32, GetLastForeignKey("PasswordQuestion_GetAll", "PasswordQuestionID"));
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.IsTrue(Affected > 0, "dbo_Membership Search Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
			
			
			
			
		}
		
		
				[TestMethod]
        public void OAuthMembership_SearchTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");
            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("OAuthMembership_Search");
			
			db.AddInParameter(cmd, "PageSize", System.Data.DbType.Int32, 10);
			db.AddInParameter(cmd, "PageNumber", System.Data.DbType.Int32, 1);
			db.AddInParameter(cmd, "SortColumn", System.Data.DbType.String, "OAuthMembershipID");
			db.AddInParameter(cmd, "SortType", System.Data.DbType.String, "asc");
			db.AddInParameter(cmd,"Provider", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"ProviderUserID", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"CreatedBy", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_CreatedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_CreatedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"ModifiedBy", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_ModifiedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_ModifiedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"Beg_UserId", System.Data.DbType.Int32, GetFirstForeignKey("UserProfile_GetAll", "UserId"));
			db.AddInParameter(cmd,"End_UserId", System.Data.DbType.Int32, GetLastForeignKey("UserProfile_GetAll", "UserId"));
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.IsTrue(Affected > 0, "dbo_OAuthMembership Search Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
			
			
			
			
		}
		
		
				[TestMethod]
        public void ApplicationRoles_SearchTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");
            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("ApplicationRoles_Search");
			
			db.AddInParameter(cmd, "PageSize", System.Data.DbType.Int32, 10);
			db.AddInParameter(cmd, "PageNumber", System.Data.DbType.Int32, 1);
			db.AddInParameter(cmd, "SortColumn", System.Data.DbType.String, "ApplicationRoleId");
			db.AddInParameter(cmd, "SortType", System.Data.DbType.String, "asc");
			db.AddInParameter(cmd,"RoleName", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"CreatedBy", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_CreatedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_CreatedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"ModifiedBy", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_ModifiedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_ModifiedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"Beg_ApplicationID", System.Data.DbType.Int32, GetFirstForeignKey("ApplicationRoles_GetAll", "ApplicationID"));
			db.AddInParameter(cmd,"End_ApplicationID", System.Data.DbType.Int32, GetLastForeignKey("ApplicationRoles_GetAll", "ApplicationID"));
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.IsTrue(Affected > 0, "dbo_ApplicationRoles Search Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
			
			
			
			
		}
		
		
				[TestMethod]
        public void UsersInRoles_SearchTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");
            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("UsersInRoles_Search");
			
			db.AddInParameter(cmd, "PageSize", System.Data.DbType.Int32, 10);
			db.AddInParameter(cmd, "PageNumber", System.Data.DbType.Int32, 1);
			db.AddInParameter(cmd, "SortColumn", System.Data.DbType.String, "UsersInRoleID");
			db.AddInParameter(cmd, "SortType", System.Data.DbType.String, "asc");
			db.AddInParameter(cmd,"CreatedBy", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_CreatedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_CreatedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"ModifiedBy", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_ModifiedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_ModifiedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"Beg_UserId", System.Data.DbType.Int32, GetFirstForeignKey("UserProfile_GetAll", "UserId"));
			db.AddInParameter(cmd,"End_UserId", System.Data.DbType.Int32, GetLastForeignKey("UserProfile_GetAll", "UserId"));
			db.AddInParameter(cmd,"Beg_ApplicationRoleId", System.Data.DbType.Int32, GetFirstForeignKey("ApplicationRoles_GetAll", "ApplicationRoleId"));
			db.AddInParameter(cmd,"End_ApplicationRoleId", System.Data.DbType.Int32, GetLastForeignKey("ApplicationRoles_GetAll", "ApplicationRoleId"));
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.IsTrue(Affected > 0, "dbo_UsersInRoles Search Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
			
			
			
			
		}
		
		
				[TestMethod]
        public void ApplicationRoles_SearchTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");
            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("Application_Search");
			
			db.AddInParameter(cmd, "PageSize", System.Data.DbType.Int32, 10);
			db.AddInParameter(cmd, "PageNumber", System.Data.DbType.Int32, 1);
			db.AddInParameter(cmd, "SortColumn", System.Data.DbType.String, "ApplicationID");
			db.AddInParameter(cmd, "SortType", System.Data.DbType.String, "asc");
			db.AddInParameter(cmd,"ApplicationName", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"CreatedBy", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_CreatedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_CreatedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"ModifiedBy", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_ModifiedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_ModifiedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.IsTrue(Affected > 0, "dbo_Application Search Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
			
			
			
			
		}
		
		
				[TestMethod]
        public void PasswordQuestion_SearchTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");
            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("PasswordQuestion_Search");
			
			db.AddInParameter(cmd, "PageSize", System.Data.DbType.Int32, 10);
			db.AddInParameter(cmd, "PageNumber", System.Data.DbType.Int32, 1);
			db.AddInParameter(cmd, "SortColumn", System.Data.DbType.String, "PasswordQuestionID");
			db.AddInParameter(cmd, "SortType", System.Data.DbType.String, "asc");
			db.AddInParameter(cmd,"PasswordQuestionDesc", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"CreatedBy", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_CreatedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_CreatedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"ModifiedBy", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_ModifiedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_ModifiedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.IsTrue(Affected > 0, "dbo_PasswordQuestion Search Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
			
			
			
			
		}
		
		
				[TestMethod]
        public void UserProfileData_SearchTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");
            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("UserProfileData_Search");
			
			db.AddInParameter(cmd, "PageSize", System.Data.DbType.Int32, 10);
			db.AddInParameter(cmd, "PageNumber", System.Data.DbType.Int32, 1);
			db.AddInParameter(cmd, "SortColumn", System.Data.DbType.String, "UserProfileDataID");
			db.AddInParameter(cmd, "SortType", System.Data.DbType.String, "asc");
			db.AddInParameter(cmd,"UPDName", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"UPDValue", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"CreatedBy", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_CreatedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_CreatedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"ModifiedBy", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_ModifiedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_ModifiedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"Beg_UserId", System.Data.DbType.Int32, GetFirstForeignKey("UserProfile_GetAll", "UserId"));
			db.AddInParameter(cmd,"End_UserId", System.Data.DbType.Int32, GetLastForeignKey("UserProfile_GetAll", "UserId"));
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.IsTrue(Affected > 0, "dbo_UserProfileData Search Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
			
			
			
			
		}
		
		
				[TestMethod]
        public void ApplicationUser_SearchTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");
            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("ApplicationUser_Search");
			
			db.AddInParameter(cmd, "PageSize", System.Data.DbType.Int32, 10);
			db.AddInParameter(cmd, "PageNumber", System.Data.DbType.Int32, 1);
			db.AddInParameter(cmd, "SortColumn", System.Data.DbType.String, "ApplicationUserID");
			db.AddInParameter(cmd, "SortType", System.Data.DbType.String, "asc");
			db.AddInParameter(cmd,"CreatedBy", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_CreatedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_CreatedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"ModifiedBy", System.Data.DbType.String, "Sample");
			db.AddInParameter(cmd,"Beg_ModifiedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"End_ModifiedDt", System.Data.DbType.DateTime, System.DateTime.Today);
			db.AddInParameter(cmd,"Beg_UserId", System.Data.DbType.Int32, GetFirstForeignKey("UserProfile_GetAll", "UserId"));
			db.AddInParameter(cmd,"End_UserId", System.Data.DbType.Int32, GetLastForeignKey("UserProfile_GetAll", "UserId"));
			db.AddInParameter(cmd,"Beg_ApplicationID", System.Data.DbType.Int32, GetFirstForeignKey("ApplicationRoles_GetAll", "ApplicationID"));
			db.AddInParameter(cmd,"End_ApplicationID", System.Data.DbType.Int32, GetLastForeignKey("ApplicationRoles_GetAll", "ApplicationID"));
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.IsTrue(Affected > 0, "dbo_ApplicationUser Search Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
			
			
			
			
		}
		
		
				
		#endregion
        #region Helper Methods
        public int GetFirstForeignKey(string spname, string prikey)
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand(spname);
			db.AddInParameter(cmd, "PageSize", System.Data.DbType.Int32, 999999);
db.AddInParameter(cmd, "PageNumber", System.Data.DbType.Int32, 1);
db.AddInParameter(cmd, "SortColumn", System.Data.DbType.String, prikey);
db.AddInParameter(cmd, "SortType", System.Data.DbType.String, "asc");
            db.AddOutParameter(cmd,"@RowsAffected",DbType.Int32,4);
            DataSet ds = db.ExecuteDataSet(cmd);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return Convert.ToInt32(ds.Tables[0].Rows[0][prikey]);
            }
            return 0;
        }

        public int GetLastForeignKey(string spname, string prikey)
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand(spname);
			db.AddInParameter(cmd, "PageSize", System.Data.DbType.Int32, 999999);
db.AddInParameter(cmd, "PageNumber", System.Data.DbType.Int32, 1);
db.AddInParameter(cmd, "SortColumn", System.Data.DbType.String, prikey);
db.AddInParameter(cmd, "SortType", System.Data.DbType.String, "asc");
            db.AddOutParameter(cmd,"@RowsAffected",DbType.Int32,4);
            DataSet ds = db.ExecuteDataSet(cmd);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return Convert.ToInt32(ds.Tables[0].Rows[ds.Tables[0].Rows.Count - 1][prikey]);
            }
            return 0;
        }
        #endregion
	}




}