
using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using System.Data;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Microsoft.Practices.EnterpriseLibrary.Data;

namespace WebSecurity.Database.Test
{
    /// <summary>
    /// Summary description for InsertUnitTests
    /// </summary>
    [TestClass]
    public class UpdateUnitTests
    {
        public UpdateUnitTests()
        {
           

           
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes

        #endregion
		#region Test Methods

        
[TestMethod]
        public void UserProfileUpdateTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("UserProfile_udt");
		DataSet ds = GetTopValue("UserProfile_GetAll");
			db.AddInParameter(cmd,"UserId", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["UserId"]);
			db.AddInParameter(cmd,"UserName", System.Data.DbType.String, ds.Tables[0].Rows[0]["UserName"]);
			db.AddInParameter(cmd,"TS", System.Data.DbType.Binary, ds.Tables[0].Rows[0]["TS"]);
			db.AddInParameter(cmd,"CreatedBy", System.Data.DbType.String, ds.Tables[0].Rows[0]["CreatedBy"]);
			db.AddInParameter(cmd,"CreatedDt", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["CreatedDt"]);
			db.AddInParameter(cmd,"ModifiedBy", System.Data.DbType.String, ds.Tables[0].Rows[0]["ModifiedBy"]);
			db.AddInParameter(cmd,"ModifiedDt", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["ModifiedDt"]);
			db.AddInParameter(cmd,"IsActive", System.Data.DbType.Boolean, ds.Tables[0].Rows[0]["IsActive"]);
			db.AddInParameter(cmd,"FirstName", System.Data.DbType.String, ds.Tables[0].Rows[0]["FirstName"]);
			db.AddInParameter(cmd,"LastName", System.Data.DbType.String, ds.Tables[0].Rows[0]["LastName"]);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.AreEqual(1, Affected, "dbo_UserProfileUpdate Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
            
        }
		[TestMethod]
        public void MembershipUpdateTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("Membership_udt");
		DataSet ds = GetTopValue("Membership_GetAll");
			db.AddInParameter(cmd,"MembershipID", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["MembershipID"]);
			db.AddInParameter(cmd,"ConfirmationToken", System.Data.DbType.String, ds.Tables[0].Rows[0]["ConfirmationToken"]);
			db.AddInParameter(cmd,"IsConfirmed", System.Data.DbType.Boolean, ds.Tables[0].Rows[0]["IsConfirmed"]);
			db.AddInParameter(cmd,"LastPasswordFailureDate", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["LastPasswordFailureDate"]);
			db.AddInParameter(cmd,"PasswordFailuresSinceLastSuccess", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["PasswordFailuresSinceLastSuccess"]);
			db.AddInParameter(cmd,"Password", System.Data.DbType.String, ds.Tables[0].Rows[0]["Password"]);
			db.AddInParameter(cmd,"PasswordChangedDate", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["PasswordChangedDate"]);
			db.AddInParameter(cmd,"PasswordSalt", System.Data.DbType.String, ds.Tables[0].Rows[0]["PasswordSalt"]);
			db.AddInParameter(cmd,"PasswordVerificationToken", System.Data.DbType.String, ds.Tables[0].Rows[0]["PasswordVerificationToken"]);
			db.AddInParameter(cmd,"PasswordVerificationTokenExpirationDate", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["PasswordVerificationTokenExpirationDate"]);
			db.AddInParameter(cmd,"TS", System.Data.DbType.Binary, ds.Tables[0].Rows[0]["TS"]);
			db.AddInParameter(cmd,"CreatedBy", System.Data.DbType.String, ds.Tables[0].Rows[0]["CreatedBy"]);
			db.AddInParameter(cmd,"CreatedDt", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["CreatedDt"]);
			db.AddInParameter(cmd,"ModifiedBy", System.Data.DbType.String, ds.Tables[0].Rows[0]["ModifiedBy"]);
			db.AddInParameter(cmd,"ModifiedDt", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["ModifiedDt"]);
			db.AddInParameter(cmd,"EmailAccount", System.Data.DbType.String, ds.Tables[0].Rows[0]["EmailAccount"]);
			db.AddInParameter(cmd,"PasswordAnswer", System.Data.DbType.String, ds.Tables[0].Rows[0]["PasswordAnswer"]);
			db.AddInParameter(cmd,"LastLoginDate", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["LastLoginDate"]);
			db.AddInParameter(cmd,"LastLockoutDate", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["LastLockoutDate"]);
			db.AddInParameter(cmd,"UserId", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["UserId"]);
			db.AddInParameter(cmd,"PasswordQuestionID", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["PasswordQuestionID"]);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.AreEqual(1, Affected, "dbo_MembershipUpdate Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
            
        }
		[TestMethod]
        public void OAuthMembershipUpdateTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("OAuthMembership_udt");
		DataSet ds = GetTopValue("OAuthMembership_GetAll");
			db.AddInParameter(cmd,"OAuthMembershipID", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["OAuthMembershipID"]);
			db.AddInParameter(cmd,"Provider", System.Data.DbType.String, ds.Tables[0].Rows[0]["Provider"]);
			db.AddInParameter(cmd,"ProviderUserID", System.Data.DbType.String, ds.Tables[0].Rows[0]["ProviderUserID"]);
			db.AddInParameter(cmd,"TS", System.Data.DbType.Binary, ds.Tables[0].Rows[0]["TS"]);
			db.AddInParameter(cmd,"CreatedBy", System.Data.DbType.String, ds.Tables[0].Rows[0]["CreatedBy"]);
			db.AddInParameter(cmd,"CreatedDt", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["CreatedDt"]);
			db.AddInParameter(cmd,"ModifiedBy", System.Data.DbType.String, ds.Tables[0].Rows[0]["ModifiedBy"]);
			db.AddInParameter(cmd,"ModifiedDt", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["ModifiedDt"]);
			db.AddInParameter(cmd,"UserId", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["UserId"]);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.AreEqual(1, Affected, "dbo_OAuthMembershipUpdate Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
            
        }
		[TestMethod]
        public void ApplicationRolesUpdateTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("ApplicationRoles_udt");
		DataSet ds = GetTopValue("ApplicationRoles_GetAll");
			db.AddInParameter(cmd,"ApplicationRoleId", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["ApplicationRoleId"]);
			db.AddInParameter(cmd,"RoleName", System.Data.DbType.String, ds.Tables[0].Rows[0]["RoleName"]);
			db.AddInParameter(cmd,"TS", System.Data.DbType.Binary, ds.Tables[0].Rows[0]["TS"]);
			db.AddInParameter(cmd,"CreatedBy", System.Data.DbType.String, ds.Tables[0].Rows[0]["CreatedBy"]);
			db.AddInParameter(cmd,"CreatedDt", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["CreatedDt"]);
			db.AddInParameter(cmd,"ModifiedBy", System.Data.DbType.String, ds.Tables[0].Rows[0]["ModifiedBy"]);
			db.AddInParameter(cmd,"ModifiedDt", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["ModifiedDt"]);
			db.AddInParameter(cmd,"ApplicationID", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["ApplicationID"]);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.AreEqual(1, Affected, "dbo_ApplicationRolesUpdate Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
            
        }
		[TestMethod]
        public void UsersInRolesUpdateTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("UsersInRoles_udt");
		DataSet ds = GetTopValue("UsersInRoles_GetAll");
			db.AddInParameter(cmd,"UsersInRoleID", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["UsersInRoleID"]);
			db.AddInParameter(cmd,"TS", System.Data.DbType.Binary, ds.Tables[0].Rows[0]["TS"]);
			db.AddInParameter(cmd,"CreatedBy", System.Data.DbType.String, ds.Tables[0].Rows[0]["CreatedBy"]);
			db.AddInParameter(cmd,"CreatedDt", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["CreatedDt"]);
			db.AddInParameter(cmd,"ModifiedBy", System.Data.DbType.String, ds.Tables[0].Rows[0]["ModifiedBy"]);
			db.AddInParameter(cmd,"ModifiedDt", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["ModifiedDt"]);
			db.AddInParameter(cmd,"UserId", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["UserId"]);
			db.AddInParameter(cmd,"ApplicationRoleId", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["ApplicationRoleId"]);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.AreEqual(1, Affected, "dbo_UsersInRolesUpdate Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
            
        }
		[TestMethod]
        public void ApplicationUpdateTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("Application_udt");
		DataSet ds = GetTopValue("Application_GetAll");
			db.AddInParameter(cmd,"ApplicationID", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["ApplicationID"]);
			db.AddInParameter(cmd,"ApplicationName", System.Data.DbType.String, ds.Tables[0].Rows[0]["ApplicationName"]);
			db.AddInParameter(cmd,"TS", System.Data.DbType.Binary, ds.Tables[0].Rows[0]["TS"]);
			db.AddInParameter(cmd,"CreatedBy", System.Data.DbType.String, ds.Tables[0].Rows[0]["CreatedBy"]);
			db.AddInParameter(cmd,"CreatedDt", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["CreatedDt"]);
			db.AddInParameter(cmd,"ModifiedBy", System.Data.DbType.String, ds.Tables[0].Rows[0]["ModifiedBy"]);
			db.AddInParameter(cmd,"ModifiedDt", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["ModifiedDt"]);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.AreEqual(1, Affected, "dbo_ApplicationUpdate Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
            
        }
		[TestMethod]
        public void PasswordQuestionUpdateTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("PasswordQuestion_udt");
		DataSet ds = GetTopValue("PasswordQuestion_GetAll");
			db.AddInParameter(cmd,"PasswordQuestionID", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["PasswordQuestionID"]);
			db.AddInParameter(cmd,"PasswordQuestionDesc", System.Data.DbType.String, ds.Tables[0].Rows[0]["PasswordQuestionDesc"]);
			db.AddInParameter(cmd,"TS", System.Data.DbType.Binary, ds.Tables[0].Rows[0]["TS"]);
			db.AddInParameter(cmd,"CreatedBy", System.Data.DbType.String, ds.Tables[0].Rows[0]["CreatedBy"]);
			db.AddInParameter(cmd,"CreatedDt", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["CreatedDt"]);
			db.AddInParameter(cmd,"ModifiedBy", System.Data.DbType.String, ds.Tables[0].Rows[0]["ModifiedBy"]);
			db.AddInParameter(cmd,"ModifiedDt", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["ModifiedDt"]);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.AreEqual(1, Affected, "dbo_PasswordQuestionUpdate Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
            
        }
		[TestMethod]
        public void UserProfileDataUpdateTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("UserProfileData_udt");
		DataSet ds = GetTopValue("UserProfileData_GetAll");
			db.AddInParameter(cmd,"UserProfileDataID", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["UserProfileDataID"]);
			db.AddInParameter(cmd,"UPDName", System.Data.DbType.String, ds.Tables[0].Rows[0]["UPDName"]);
			db.AddInParameter(cmd,"UPDValue", System.Data.DbType.String, ds.Tables[0].Rows[0]["UPDValue"]);
			db.AddInParameter(cmd,"TS", System.Data.DbType.Binary, ds.Tables[0].Rows[0]["TS"]);
			db.AddInParameter(cmd,"CreatedBy", System.Data.DbType.String, ds.Tables[0].Rows[0]["CreatedBy"]);
			db.AddInParameter(cmd,"CreatedDt", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["CreatedDt"]);
			db.AddInParameter(cmd,"ModifiedBy", System.Data.DbType.String, ds.Tables[0].Rows[0]["ModifiedBy"]);
			db.AddInParameter(cmd,"ModifiedDt", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["ModifiedDt"]);
			db.AddInParameter(cmd,"UserId", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["UserId"]);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.AreEqual(1, Affected, "dbo_UserProfileDataUpdate Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
            
        }
		[TestMethod]
        public void ApplicationUserUpdateTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("ApplicationUser_udt");
		DataSet ds = GetTopValue("ApplicationUser_GetAll");
			db.AddInParameter(cmd,"ApplicationUserID", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["ApplicationUserID"]);
			db.AddInParameter(cmd,"TS", System.Data.DbType.Binary, ds.Tables[0].Rows[0]["TS"]);
			db.AddInParameter(cmd,"CreatedBy", System.Data.DbType.String, ds.Tables[0].Rows[0]["CreatedBy"]);
			db.AddInParameter(cmd,"CreatedDt", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["CreatedDt"]);
			db.AddInParameter(cmd,"ModifiedBy", System.Data.DbType.String, ds.Tables[0].Rows[0]["ModifiedBy"]);
			db.AddInParameter(cmd,"ModifiedDt", System.Data.DbType.DateTime, ds.Tables[0].Rows[0]["ModifiedDt"]);
			db.AddInParameter(cmd,"UserId", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["UserId"]);
			db.AddInParameter(cmd,"ApplicationID", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["ApplicationID"]);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.AreEqual(1, Affected, "dbo_ApplicationUserUpdate Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
            
        }
				#endregion
		#region Helper Methods
        public DataSet GetTopValue(string spname)
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");
            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand(spname);
            db.AddOutParameter(cmd,"@RowsAffected",DbType.Int32,4);
            DataSet ds = db.ExecuteDataSet(cmd);
            
            return ds;
           
        }
        #endregion
    }
}