using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using System.Data;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Microsoft.Practices.EnterpriseLibrary.Data;

namespace WebSecurity.Database.Test
{
    /// <summary>
    /// Summary description for InsertUnitTests
    /// </summary>
    [TestClass]
    public class ByPkUnitTests
    {
        public ByPkUnitTests()
        {
           

           
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes

        #endregion
		#region Test Methods

        
[TestMethod]
        public void UserProfileByPkTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("UserProfile_GetOne");
		DataSet ds = GetTopValue("UserProfile_GetAll");
			db.AddInParameter(cmd,"UserId", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["UserId"]);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.AreEqual(1, Affected, "dbo_UserProfile ByPk Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
            
        }
		[TestMethod]
        public void MembershipByPkTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("Membership_GetOne");
		DataSet ds = GetTopValue("Membership_GetAll");
			db.AddInParameter(cmd,"MembershipID", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["MembershipID"]);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.AreEqual(1, Affected, "dbo_Membership ByPk Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
            
        }
		[TestMethod]
        public void OAuthMembershipByPkTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("OAuthMembership_GetOne");
		DataSet ds = GetTopValue("OAuthMembership_GetAll");
			db.AddInParameter(cmd,"OAuthMembershipID", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["OAuthMembershipID"]);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.AreEqual(1, Affected, "dbo_OAuthMembership ByPk Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
            
        }
		[TestMethod]
        public void ApplicationRolesByPkTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("ApplicationRoles_GetOne");
		DataSet ds = GetTopValue("ApplicationRoles_GetAll");
			db.AddInParameter(cmd,"ApplicationRoleId", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["ApplicationRoleId"]);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.AreEqual(1, Affected, "dbo_ApplicationRoles ByPk Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
            
        }
		[TestMethod]
        public void UsersInRolesByPkTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("UsersInRoles_GetOne");
		DataSet ds = GetTopValue("UsersInRoles_GetAll");
			db.AddInParameter(cmd,"UsersInRoleID", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["UsersInRoleID"]);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.AreEqual(1, Affected, "dbo_UsersInRoles ByPk Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
            
        }
		[TestMethod]
        public void ApplicationByPkTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("Application_GetOne");
		DataSet ds = GetTopValue("Application_GetAll");
			db.AddInParameter(cmd,"ApplicationID", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["ApplicationID"]);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.AreEqual(1, Affected, "dbo_Application ByPk Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
            
        }
		[TestMethod]
        public void PasswordQuestionByPkTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("PasswordQuestion_GetOne");
		DataSet ds = GetTopValue("PasswordQuestion_GetAll");
			db.AddInParameter(cmd,"PasswordQuestionID", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["PasswordQuestionID"]);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.AreEqual(1, Affected, "dbo_PasswordQuestion ByPk Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
            
        }
		[TestMethod]
        public void UserProfileDataByPkTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("UserProfileData_GetOne");
		DataSet ds = GetTopValue("UserProfileData_GetAll");
			db.AddInParameter(cmd,"UserProfileDataID", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["UserProfileDataID"]);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.AreEqual(1, Affected, "dbo_UserProfileData ByPk Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
            
        }
		[TestMethod]
        public void ApplicationUserByPkTest()
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");

            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand("ApplicationUser_GetOne");
		DataSet ds = GetTopValue("ApplicationUser_GetAll");
			db.AddInParameter(cmd,"ApplicationUserID", System.Data.DbType.Int32, ds.Tables[0].Rows[0]["ApplicationUserID"]);
			db.AddOutParameter(cmd,"@RowsAffected", DbType.Int32,4);
			int RetVal = db.ExecuteNonQuery(cmd);
			int Affected = Convert.ToInt32(db.GetParameterValue(cmd, "@RowsAffected"));
			Assert.AreEqual(1, Affected, "dbo_ApplicationUser ByPk Test Failed");
			cmd.Connection.Close();
			cmd.Dispose();
			db = null;
            
        }
				#endregion
		#region Helper Methods
        public DataSet GetTopValue(string spname)
        {
            Microsoft.Practices.EnterpriseLibrary.Data.Database db = DatabaseFactory.CreateDatabase("WebSecurity");
            System.Data.Common.DbCommand cmd = db.GetStoredProcCommand(spname);
            db.AddOutParameter(cmd,"@RowsAffected",DbType.Int32,4);
            DataSet ds = db.ExecuteDataSet(cmd);
            cmd.Connection.Close();
            cmd.Dispose();
            return ds;
           
        }
        #endregion
    }
}