
use WebSecurity;
GO
-- Drop stored procedure if it already exists
IF EXISTS (
  SELECT * 
    FROM INFORMATION_SCHEMA.ROUTINES 
   WHERE SPECIFIC_CATALOG = N'WebSecurity' 
	 AND SPECIFIC_SCHEMA = N'dbo'
     AND SPECIFIC_NAME = N'ApplicationProfileData_del' 
)
   DROP PROCEDURE dbo.ApplicationProfileData_del
GO
create procedure ApplicationProfileData_del
	@ApplicationProfileDataID Int,
	@TS varbinary(8),	@RowsAffected int = null OUTPUT 
	
--*************************************************************
--Created By: trooks
--Name: dbo_ApplicationProfileData_del
--Table: ApplicationProfileData
--Database: WebSecurity
--Created Date: 01/21/2013 00:00:00
--*************************************************************

as
	Begin Try
		Delete From [dbo].ApplicationProfileData
		 where
		 @ApplicationProfileDataID = ApplicationProfileDataID
		AND @TS = TS

		Set @RowsAffected = @@ROWCOUNT;
		return 0;	
	END TRY
	BEGIN CATCH
		Set @RowsAffected = 0;
		EXEC dbo.uspLogError;
		return -1;
	END CATCH
	
GO
GRANT EXECUTE ON [WebSecurity].[dbo].[ApplicationProfileData_del] to PORTAL_WebSecurity
GO
