

USE [WebSecurity]
GO

GO
-- Drop stored procedure if it already exists
IF EXISTS (
  SELECT * 
    FROM INFORMATION_SCHEMA.ROUTINES 
   WHERE SPECIFIC_CATALOG = N'WebSecurity' 
	 AND SPECIFIC_SCHEMA = N'dbo'
     AND SPECIFIC_NAME = N'ApplicationProfileData_ins' 
)
   DROP PROCEDURE dbo.ApplicationProfileData_ins
GO
create procedure ApplicationProfileData_ins

	@ApplicationProfileDataID Int = null OUTPUT,
	@ApplicationProfileDataKey NVarChar(100),
	@ApplicationProfileDataValue NVarChar(4),
	@CreatedBy VarChar(50),
	@CreatedDt DateTime,
	@ModifiedBy VarChar(50),
	@ModifiedDt DateTime,
	@ApplicationID Int,
        @RowsAffected int = null OUTPUT 
	
--*************************************************************
--Created By: trooks
--Name: dbo_ApplicationProfileData_ins
--Schema: dbo
--Table: ApplicationProfileData
--Database: WebSecurity
--Created Date: 01/21/2013 00:00:00
--*************************************************************

as
	Begin Try
        insert into [dbo].ApplicationProfileData
		(
		ApplicationProfileDataKey, 
		[ApplicationProfileDataValue], 
		CreatedBy, 
		CreatedDt, 
		ModifiedBy, 
		ModifiedDt, 
		ApplicationID 
    )
    values
    (
		@ApplicationProfileDataKey, 
		@ApplicationProfileDataValue, 
		@CreatedBy, 
		@CreatedDt, 
		@ModifiedBy, 
		@ModifiedDt, 
		@ApplicationID 
        )
		Set @ApplicationProfileDataID = SCOPE_IDENTITY(); 
		Set @RowsAffected = @@ROWCOUNT;
		return 0;	
	END TRY
	BEGIN CATCH
		Set @RowsAffected = 0;
		EXEC dbo.uspLogError;
		return -1;
	END CATCH
	
GO
GRANT EXECUTE ON [WebSecurity].[dbo].[ApplicationProfileData_ins] to PORTAL_WebSecurity
GO




