
use WebSecurity;
GO
-- Drop stored procedure if it already exists
IF EXISTS (
  SELECT * 
    FROM INFORMATION_SCHEMA.ROUTINES 
   WHERE SPECIFIC_CATALOG = N'WebSecurity' 
	 AND SPECIFIC_SCHEMA = N'dbo'
     AND SPECIFIC_NAME = N'ApplicationUser_GetOne' 
)
   DROP PROCEDURE dbo.ApplicationUser_GetOne
GO
create procedure dbo.ApplicationUser_GetOne
@ApplicationUserID Int = null OUTPUT,
	@RowsAffected int = null OUTPUT 
	
--*************************************************************
--Created By: trooks
--Name: dbo_ApplicationUser_GetOne
--Table: ApplicationUser 
--Schema: dbo
--Database: WebSecurity
--Created Date: 01/21/2013 00:00:00
--*************************************************************

as
	Begin Try
		Select 
		ApplicationUserID, 
		TS, 
		CreatedBy, 
		CreatedDt, 
		ModifiedBy, 
		ModifiedDt, 
		UserId, 
		ApplicationID 
		From [dbo].ApplicationUser
		 where
		 @ApplicationUserID = ApplicationUserID

		Set @RowsAffected = @@ROWCOUNT;
		return 0;	
	END TRY
	BEGIN CATCH
		Set @RowsAffected = 0;
		EXEC dbo.uspLogError;
		return -1;
	END CATCH
	
GO
GRANT EXECUTE ON [WebSecurity].[dbo].[ApplicationUser_GetOne] to PORTAL_WebSecurity
GO