
use WebSecurity;
GO
-- Drop stored procedure if it already exists
IF EXISTS (
  SELECT * 
    FROM INFORMATION_SCHEMA.ROUTINES 
   WHERE SPECIFIC_CATALOG = N'WebSecurity' 
	 AND SPECIFIC_SCHEMA = N'dbo'
     AND SPECIFIC_NAME = N'PasswordQuestion_del' 
)
   DROP PROCEDURE dbo.PasswordQuestion_del
GO
create procedure PasswordQuestion_del
	@PasswordQuestionID Int,
	@TS varbinary(8),	@RowsAffected int = null OUTPUT 
	
--*************************************************************
--Created By: trooks
--Name: dbo_PasswordQuestion_del
--Table: PasswordQuestion
--Database: WebSecurity
--Created Date: 01/21/2013 00:00:00
--*************************************************************

as
	Begin Try
		Delete From [dbo].PasswordQuestion
		 where
		 @PasswordQuestionID = PasswordQuestionID
		AND @TS = TS

		Set @RowsAffected = @@ROWCOUNT;
		return 0;	
	END TRY
	BEGIN CATCH
		Set @RowsAffected = 0;
		EXEC dbo.uspLogError;
		return -1;
	END CATCH
	
GO
GRANT EXECUTE ON [WebSecurity].[dbo].[PasswordQuestion_del] to PORTAL_WebSecurity
GO
