
use WebSecurity;
GO
-- Drop stored procedure if it already exists
IF EXISTS (
  SELECT * 
    FROM INFORMATION_SCHEMA.ROUTINES 
   WHERE SPECIFIC_CATALOG = N'WebSecurity' 
	 AND SPECIFIC_SCHEMA = N'dbo'
     AND SPECIFIC_NAME = N'PasswordQuestion_GetOne' 
)
   DROP PROCEDURE dbo.PasswordQuestion_GetOne
GO
create procedure dbo.PasswordQuestion_GetOne
@PasswordQuestionID Int = null OUTPUT,
	@RowsAffected int = null OUTPUT 
	
--*************************************************************
--Created By: trooks
--Name: dbo_PasswordQuestion_GetOne
--Table: PasswordQuestion 
--Schema: dbo
--Database: WebSecurity
--Created Date: 01/21/2013 00:00:00
--*************************************************************

as
	Begin Try
		Select 
		PasswordQuestionID, 
		PasswordQuestionDesc, 
		TS, 
		CreatedBy, 
		CreatedDt, 
		ModifiedBy, 
		ModifiedDt 
		From [dbo].PasswordQuestion
		 where
		 @PasswordQuestionID = PasswordQuestionID

		Set @RowsAffected = @@ROWCOUNT;
		return 0;	
	END TRY
	BEGIN CATCH
		Set @RowsAffected = 0;
		EXEC dbo.uspLogError;
		return -1;
	END CATCH
	
GO
GRANT EXECUTE ON [WebSecurity].[dbo].[PasswordQuestion_GetOne] to PORTAL_WebSecurity
GO