
use WebSecurity;
GO
-- Drop stored procedure if it already exists
IF EXISTS (
  SELECT * 
    FROM INFORMATION_SCHEMA.ROUTINES 
   WHERE SPECIFIC_CATALOG = N'WebSecurity' 
	 AND SPECIFIC_SCHEMA = N'dbo'
     AND SPECIFIC_NAME = N'UserProfileData_GetOne' 
)
   DROP PROCEDURE dbo.UserProfileData_GetOne
GO
create procedure dbo.UserProfileData_GetOne
@UserProfileDataID Int = null OUTPUT,
	@RowsAffected int = null OUTPUT 
	
--*************************************************************
--Created By: trooks
--Name: dbo_UserProfileData_GetOne
--Table: UserProfileData 
--Schema: dbo
--Database: WebSecurity
--Created Date: 01/21/2013 00:00:00
--*************************************************************

as
	Begin Try
		Select 
		UserProfileDataID, 
		UPDName, 
		UPDValue, 
		TS, 
		CreatedBy, 
		CreatedDt, 
		ModifiedBy, 
		ModifiedDt, 
		UserId 
		From [dbo].UserProfileData
		 where
		 @UserProfileDataID = UserProfileDataID

		Set @RowsAffected = @@ROWCOUNT;
		return 0;	
	END TRY
	BEGIN CATCH
		Set @RowsAffected = 0;
		EXEC dbo.uspLogError;
		return -1;
	END CATCH
	
GO
GRANT EXECUTE ON [WebSecurity].[dbo].[UserProfileData_GetOne] to PORTAL_WebSecurity
GO