
use WebSecurity;
GO
-- Drop stored procedure if it already exists
IF EXISTS (
  SELECT * 
    FROM INFORMATION_SCHEMA.ROUTINES 
   WHERE SPECIFIC_CATALOG = N'WebSecurity' 
	 AND SPECIFIC_SCHEMA = N'dbo'
     AND SPECIFIC_NAME = N'UserProfileData_udt' 
)
   DROP PROCEDURE dbo.UserProfileData_udt
GO
create procedure dbo.UserProfileData_udt
	@UserProfileDataID Int,
	@UPDName NVarChar(100),
	@UPDValue NVarChar(100),
	@TS varbinary(8),
	@CreatedBy VarChar(50),
	@CreatedDt DateTime,
	@ModifiedBy VarChar(50),
	@ModifiedDt DateTime,
	@UserId Int,
	@RowsAffected int = null OUTPUT 
	
--*************************************************************
--Created By: trooks
--Name: dbo_UserProfileData_udt
--Table: UserProfileData
--Database: WebSecurity
--Created Date: 01/21/2013 00:00:00
--*************************************************************

as
    Begin Try
		update [dbo].UserProfileData
        Set

		UPDName = @UPDName, 
		UPDValue = @UPDValue, 
		CreatedBy = @CreatedBy, 
		CreatedDt = @CreatedDt, 
		ModifiedBy = @ModifiedBy, 
		ModifiedDt = @ModifiedDt, 
		UserId = @UserId 
    where
		 @UserProfileDataID = UserProfileDataID
		AND @TS = TS
		Set @RowsAffected = @@ROWCOUNT;
		return 0;	
	END TRY
	BEGIN CATCH
		Set @RowsAffected = 0;
		EXEC dbo.uspLogError;
		return -1;
	END CATCH
	
GO
GRANT EXECUTE ON [WebSecurity].[dbo].[UserProfileData_udt] to PORTAL_WebSecurity
GO













