using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Web;
using System.Web.Mvc;
using T2.WebSecurity.Business;
using T2.WebSecurity.ASPMVC.Entity;
using T2.WebSecurity.ASPMVC.Entity.Interface;
using T2.WebSecurity.ASPMVC.Entity.Search;
using T2.WebSecurity.ASPMVC.Entity.Search.Interface;
using T2.WebSecurity.Business.Entities;
using T2.WebSecurity.Business.Entities.Interfaces;
using T2.WebSecurity.ASPMVC.Entity.Translators;
using T2.WebSecurity.Business.Entities.Search.Interfaces;
using T2.WebSecurity.Business.Entities.Search;
using T2.WebSecurity.ASPMVC.ViewModel;
using T2.WebSecurity.Common.Log;
using T2.WebSecurity.Common;

namespace T2.WebSecurity.ASPMVC.Controllers
{
    public partial class ApplicationController : Controller
    {
        
		public ActionResult NewApplicationForm()
        {
            try
            {
				ApplicationViewModel model = new ApplicationViewModel(true);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("NewApplicationForm", model);
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in Application View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }

        

        public ActionResult ApplicationAccordion()
        {
            try
            {
				return View("ApplicationAccordion");
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in Application View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }

        public ActionResult ApplicationSearchAccordion()
        {
            try
            {
				return View("ApplicationSearchAccordion");
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in Application View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }
		
		public ActionResult UpdateApplicationForm(string id)
        {
            try
            {
				ApplicationViewModel model = new ApplicationViewModel(true);
				Application_ui tempParam = new Application_ui();
				tempParam.Action = "GetOne";
               tempParam.ApplicationID = Convert.ToInt32(id);
                model.LoadModel(tempParam);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("UpdateApplicationForm", model);
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in Application View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }


        public ActionResult ApplicationDetails(string id)
        {
            try
            {
				ApplicationViewModel model = new ApplicationViewModel(true);
				Application_ui tempParam = new Application_ui();
				tempParam.Action = "GetOne";
                tempParam.ApplicationID = Convert.ToInt32(id);
				model.LoadModel(tempParam);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("ApplicationDetails", model);
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in Application View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }
		
		public ActionResult ApplicationGrid()
        {
			try
            {
				ApplicationViewModel model = new ApplicationViewModel(false);
				ViewData.Model = model;
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
            	return View("ApplicationGrid");
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in Application View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message);  
			}
        }

		public ActionResult ApplicationSearch()
		{
			try
			{
				ApplicationViewModel model = new ApplicationViewModel(true);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("ApplicationSearch", model);
			}
			 catch (Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in Application View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
		}


		
		


    }
}