using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Web;
using System.Web.Mvc;
using T2.WebSecurity.Business;
using T2.WebSecurity.ASPMVC.Entity;
using T2.WebSecurity.ASPMVC.Entity.Interface;
using T2.WebSecurity.ASPMVC.Entity.Search;
using T2.WebSecurity.ASPMVC.Entity.Search.Interface;
using T2.WebSecurity.Business.Entities;
using T2.WebSecurity.Business.Entities.Interfaces;
using T2.WebSecurity.ASPMVC.Entity.Translators;
using T2.WebSecurity.Business.Entities.Search.Interfaces;
using T2.WebSecurity.Business.Entities.Search;
using T2.WebSecurity.ASPMVC.ViewModel;
using T2.WebSecurity.Common.Log;
using T2.WebSecurity.Common;

namespace T2.WebSecurity.ASPMVC.Controllers
{
    public partial class ApplicationRolesController : Controller
    {
        
		public ActionResult NewApplicationRolesForm()
        {
            try
            {
				ApplicationRolesViewModel model = new ApplicationRolesViewModel(true);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("NewApplicationRolesForm", model);
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationRolesController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in ApplicationRoles View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }

        

        public ActionResult ApplicationRolesAccordion()
        {
            try
            {
				return View("ApplicationRolesAccordion");
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationRolesController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in ApplicationRoles View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }

        public ActionResult ApplicationRolesSearchAccordion()
        {
            try
            {
				return View("ApplicationRolesSearchAccordion");
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationRolesController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in ApplicationRoles View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }
		
		public ActionResult UpdateApplicationRolesForm(string id)
        {
            try
            {
				ApplicationRolesViewModel model = new ApplicationRolesViewModel(true);
				ApplicationRoles_ui tempParam = new ApplicationRoles_ui();
				tempParam.Action = "GetOne";
				tempParam.ApplicationRoleId = Convert.ToInt32(id);
				model.LoadModel(tempParam);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("UpdateApplicationRolesForm", model);
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationRolesController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in ApplicationRoles View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }


        public ActionResult ApplicationRolesDetails(string id)
        {
            try
            {
				ApplicationRolesViewModel model = new ApplicationRolesViewModel(true);
				ApplicationRoles_ui tempParam = new ApplicationRoles_ui();
				tempParam.Action = "GetOne";
				tempParam.ApplicationRoleId = Convert.ToInt32(id);
				model.LoadModel(tempParam);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("ApplicationRolesDetails", model);
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationRolesController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in ApplicationRoles View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }
		
		public ActionResult ApplicationRolesGrid()
        {
			try
            {
				ApplicationRolesViewModel model = new ApplicationRolesViewModel(false);
				ViewData.Model = model;
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
            	return View("ApplicationRolesGrid");
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationRolesController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in ApplicationRoles View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message);  
			}
        }

		public ActionResult ApplicationRolesSearch()
		{
			try
			{
				ApplicationRolesViewModel model = new ApplicationRolesViewModel(true);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("ApplicationRolesSearch", model);
			}
			 catch (Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationRolesController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in ApplicationRoles View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
		}


		
		


    }
}