using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Web;
using System.Web.Mvc;
using T2.WebSecurity.Business;
using T2.WebSecurity.ASPMVC.Entity;
using T2.WebSecurity.ASPMVC.Entity.Interface;
using T2.WebSecurity.ASPMVC.Entity.Search;
using T2.WebSecurity.ASPMVC.Entity.Search.Interface;
using T2.WebSecurity.Business.Entities;
using T2.WebSecurity.Business.Entities.Interfaces;
using T2.WebSecurity.ASPMVC.Entity.Translators;
using T2.WebSecurity.Business.Entities.Search.Interfaces;
using T2.WebSecurity.Business.Entities.Search;
using T2.WebSecurity.ASPMVC.ViewModel;
using T2.WebSecurity.Common.Log;
using T2.WebSecurity.Common;

namespace T2.WebSecurity.ASPMVC.Controllers
{
    public partial class ApplicationUserController : Controller
    {
        
		public ActionResult NewApplicationUserForm()
        {
            try
            {
				ApplicationUserViewModel model = new ApplicationUserViewModel(true);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("NewApplicationUserForm", model);
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationUserController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in ApplicationUser View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }

        

        public ActionResult ApplicationUserAccordion()
        {
            try
            {
				return View("ApplicationUserAccordion");
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationUserController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in ApplicationUser View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }

        public ActionResult ApplicationUserSearchAccordion()
        {
            try
            {
				return View("ApplicationUserSearchAccordion");
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationUserController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in ApplicationUser View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }
		
		public ActionResult UpdateApplicationUserForm(string id)
        {
            try
            {
				ApplicationUserViewModel model = new ApplicationUserViewModel(true);
				ApplicationUser_ui tempParam = new ApplicationUser_ui();
				tempParam.Action = "GetOne";
				tempParam.ApplicationUserID = Convert.ToInt32(id);
				model.LoadModel(tempParam);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("UpdateApplicationUserForm", model);
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationUserController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in ApplicationUser View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }


        public ActionResult ApplicationUserDetails(string id)
        {
            try
            {
				ApplicationUserViewModel model = new ApplicationUserViewModel(true);
				ApplicationUser_ui tempParam = new ApplicationUser_ui();
				tempParam.Action = "GetOne";
				tempParam.ApplicationUserID = Convert.ToInt32(id);
				model.LoadModel(tempParam);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("ApplicationUserDetails", model);
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationUserController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in ApplicationUser View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }
		
		public ActionResult ApplicationUserGrid()
        {
			try
            {
				ApplicationUserViewModel model = new ApplicationUserViewModel(false);
				ViewData.Model = model;
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
            	return View("ApplicationUserGrid");
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationUserController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in ApplicationUser View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message);  
			}
        }

		public ActionResult ApplicationUserSearch()
		{
			try
			{
				ApplicationUserViewModel model = new ApplicationUserViewModel(true);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("ApplicationUserSearch", model);
			}
			 catch (Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in ApplicationUserController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in ApplicationUser View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
		}


		
		


    }
}