using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Web;
using System.Web.Mvc;
using T2.WebSecurity.Business;
using T2.WebSecurity.ASPMVC.Entity;
using T2.WebSecurity.ASPMVC.Entity.Interface;
using T2.WebSecurity.ASPMVC.Entity.Search;
using T2.WebSecurity.ASPMVC.Entity.Search.Interface;
using T2.WebSecurity.Business.Entities;
using T2.WebSecurity.Business.Entities.Interfaces;
using T2.WebSecurity.ASPMVC.Entity.Translators;
using T2.WebSecurity.Business.Entities.Search.Interfaces;
using T2.WebSecurity.Business.Entities.Search;
using T2.WebSecurity.ASPMVC.ViewModel;
using T2.WebSecurity.Common.Log;
using T2.WebSecurity.Common;

namespace T2.WebSecurity.ASPMVC.Controllers
{
    public partial class MembershipController : Controller
    {
        
		public ActionResult NewMembershipForm()
        {
            try
            {
				MembershipViewModel model = new MembershipViewModel(true);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("NewMembershipForm", model);
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in MembershipController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in Membership View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }

        

        public ActionResult MembershipAccordion()
        {
            try
            {
				return View("MembershipAccordion");
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in MembershipController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in Membership View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }

        public ActionResult MembershipSearchAccordion()
        {
            try
            {
				return View("MembershipSearchAccordion");
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in MembershipController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in Membership View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }
		
		public ActionResult UpdateMembershipForm(string id)
        {
            try
            {
				MembershipViewModel model = new MembershipViewModel(true);
				Membership_ui tempParam = new Membership_ui();
				tempParam.Action = "GetOne";
				tempParam.MembershipID = Convert.ToInt32(id);
				model.LoadModel(tempParam);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("UpdateMembershipForm", model);
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in MembershipController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in Membership View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }


        public ActionResult MembershipDetails(string id)
        {
            try
            {
				MembershipViewModel model = new MembershipViewModel(true);
				Membership_ui tempParam = new Membership_ui();
				tempParam.Action = "GetOne";
				tempParam.MembershipID = Convert.ToInt32(id);
				model.LoadModel(tempParam);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("MembershipDetails", model);
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in MembershipController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in Membership View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }
		
		public ActionResult MembershipGrid()
        {
			try
            {
				MembershipViewModel model = new MembershipViewModel(false);
				ViewData.Model = model;
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
            	return View("MembershipGrid");
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in MembershipController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in Membership View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message);  
			}
        }

		public ActionResult MembershipSearch()
		{
			try
			{
				MembershipViewModel model = new MembershipViewModel(true);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("MembershipSearch", model);
			}
			 catch (Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in MembershipController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in Membership View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
		}


		
		


    }
}