using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using T2.WebSecurity.Business;
using T2.WebSecurity.ASPMVC.Entity;
using T2.WebSecurity.ASPMVC.Entity.Interface;
using T2.WebSecurity.ASPMVC.Entity.Search;
using T2.WebSecurity.ASPMVC.Entity.Search.Interface;
using T2.WebSecurity.Business.Entities;
using T2.WebSecurity.Business.Entities.Interfaces;
using T2.WebSecurity.ASPMVC.Entity.Translators;
using T2.WebSecurity.Business.Entities.Search.Interfaces;
using T2.WebSecurity.Business.Entities.Search;
using T2.WebSecurity.ASPMVC.ViewModel;
using System.Web.Http;
using System.Net.Http;
using System.Net;

namespace T2.WebSecurity.ASPMVC.Controllers
{
    public partial class PasswordQuestionAPIController : ApiController
    {
        public HttpResponseMessage PostPasswordQuestion(PasswordQuestion_ui param)
        {
            try
            {
                PasswordQuestionViewModel model = new PasswordQuestionViewModel(false);
                Int32 retVal = model.Set(param);
                if (retVal == 1)
                {
                    HttpResponseMessage message = new HttpResponseMessage();
                    message.ReasonPhrase = "Completed saving PasswordQuestion";
                    message.StatusCode = HttpStatusCode.OK;
                    return message;
                }
                else
                {
                    HttpResponseMessage message = new HttpResponseMessage();
                    message.ReasonPhrase = "PasswordQuestion did not save";
                    message.StatusCode = HttpStatusCode.NotAcceptable;
                    return message;
                }
            }
            catch (Exception ex)
            {
                HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = ex.Message;
                message.StatusCode = HttpStatusCode.InternalServerError;
                return message;
            }
        }	

		public List<IPasswordQuestion_ui> GetPasswordQuestion(string Action, string Caller, string SortColumn, string SortType, string Role, int PageNumber, int PageSize)
        {
            try
            {
                PasswordQuestion_ui param = new PasswordQuestion_ui();
                param.Action = Action;
                param.Caller = Caller;
                param.SortColumn = SortColumn;
                param.SortType = SortType;
                param.Role = Role;
                param.PageNumber = PageNumber;
                param.PageSize = PageSize;
                PasswordQuestionViewModel model = new PasswordQuestionViewModel(false);
                List<IPasswordQuestion_ui> retVal = model.ModelList(param);
                return retVal;
            }
            catch (Exception ex)
            {
                HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = ex.Message;
                message.StatusCode = HttpStatusCode.InternalServerError;
                throw new HttpResponseException(message);  
            }
        }
		
		public List<IPasswordQuestion_ui> GetPasswordQuestionSearch(PasswordQuestionSearch_ui param)
        {
            try
            {
                PasswordQuestionViewModel model = new PasswordQuestionViewModel(false);
                List<IPasswordQuestion_ui> retVal = model.SearchList(param);
                return retVal;
            }
            catch (Exception ex)
            {
                HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = ex.Message;
                message.StatusCode = HttpStatusCode.InternalServerError;
                throw new HttpResponseException(message);  
            }
        }	


    }
}