using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Web;
using System.Web.Mvc;
using T2.WebSecurity.Business;
using T2.WebSecurity.ASPMVC.Entity;
using T2.WebSecurity.ASPMVC.Entity.Interface;
using T2.WebSecurity.ASPMVC.Entity.Search;
using T2.WebSecurity.ASPMVC.Entity.Search.Interface;
using T2.WebSecurity.Business.Entities;
using T2.WebSecurity.Business.Entities.Interfaces;
using T2.WebSecurity.ASPMVC.Entity.Translators;
using T2.WebSecurity.Business.Entities.Search.Interfaces;
using T2.WebSecurity.Business.Entities.Search;
using T2.WebSecurity.ASPMVC.ViewModel;
using T2.WebSecurity.Common.Log;
using T2.WebSecurity.Common;

namespace T2.WebSecurity.ASPMVC.Controllers
{
    public partial class UserProfileController : Controller
    {
        
		public ActionResult NewUserProfileForm()
        {
            try
            {
				UserProfileViewModel model = new UserProfileViewModel(true);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("NewUserProfileForm", model);
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in UserProfileController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in UserProfile View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }

        

        public ActionResult UserProfileAccordion()
        {
            try
            {
				return View("UserProfileAccordion");
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in UserProfileController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in UserProfile View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }

        public ActionResult UserProfileSearchAccordion()
        {
            try
            {
				return View("UserProfileSearchAccordion");
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in UserProfileController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in UserProfile View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }
		
		public ActionResult UpdateUserProfileForm(string id)
        {
            try
            {
				UserProfileViewModel model = new UserProfileViewModel(true);
				UserProfile_ui tempParam = new UserProfile_ui();
				tempParam.Action = "GetOne";
				tempParam.UserId = Convert.ToInt32(id);
				model.LoadModel(tempParam);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("UpdateUserProfileForm", model);
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in UserProfileController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in UserProfile View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }


        public ActionResult UserProfileDetails(string id)
        {
            try
            {
				UserProfileViewModel model = new UserProfileViewModel(true);
				UserProfile_ui tempParam = new UserProfile_ui();
				tempParam.Action = "GetOne";
				tempParam.UserId = Convert.ToInt32(id);
				model.LoadModel(tempParam);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("UserProfileDetails", model);
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in UserProfileController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in UserProfile View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
			
        }
		
		public ActionResult UserProfileGrid()
        {
			try
            {
				UserProfileViewModel model = new UserProfileViewModel(false);
				ViewData.Model = model;
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
            	return View("UserProfileGrid");
			}
            catch(Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in UserProfileController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in UserProfile View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message);  
			}
        }

		public ActionResult UserProfileSearch()
		{
			try
			{
				UserProfileViewModel model = new UserProfileViewModel(true);
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				return View("UserProfileSearch", model);
			}
			 catch (Exception ex)
			{
				MyLogger.MyLog("T2.WebSecurity","Business","Error occured in UserProfileController Workflow", MyEnum.LogCategories.Error, 10, 7010, System.Diagnostics.TraceEventType.Error, "Unknown Error Has Occured");
				HttpResponseMessage message = new HttpResponseMessage();
                message.ReasonPhrase = "Server error has occured in UserProfile View Controller";
                message.StatusCode = HttpStatusCode.NotFound;
                throw new HttpResponseException(message); 
			}
		}


		
		


    }
}