using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using T2.WebSecurity.ASPMVC.Entity;
using T2.WebSecurity.ASPMVC.Entity.Interface;
using T2.WebSecurity.Business.Entities.Interfaces;
using T2.WebSecurity.Business.Entities;
using T2.WebSecurity.ASPMVC.Entity.Translators;

//--Change Management Control - DomainName ASPMVC Entity Translator  --**********************
//--Created By: James Rooks
//--Description: DomainName Translator
//--Created Date: 02/05/2013 18:24:39
//--*************************************************************
namespace T2.WebSecurity.ASPMVC.Entity.Translators
{
	public class DomainNameUITranslator 
	{
		public IDomainName_biz TranslateToBusinessLayer(IDomainName_ui _translateFrom)
        {
            IDomainName_biz temp = new DomainName_biz();
		
			if(_translateFrom != null)
			{
			    temp.Action = _translateFrom.Action;
                temp.Caller = _translateFrom.Caller;
                temp.Role = _translateFrom.Role;
                temp.PageSize = _translateFrom.PageSize;
                temp.PageNumber = _translateFrom.PageNumber;
                temp.SortColumn = _translateFrom.SortColumn;
                temp.SortType = _translateFrom.SortType;
                temp.TotalRows = _translateFrom.TotalRows;
			if (_translateFrom.DomainNameID != null)
			{
				temp.DomainNameID = _translateFrom.DomainNameID;
			}
			else
			{
			temp.DomainNameID = -1;
			}
			if (_translateFrom.EmailDomain != null)
			{
				temp.EmailDomain = _translateFrom.EmailDomain;
			}
			else
			{
			temp.EmailDomain = String.Empty;
			}
			if (_translateFrom.DomainDeny != null)
			{
				temp.DomainDeny = _translateFrom.DomainDeny;
			}
			else
			{
			temp.DomainDeny = false;
			}
			if (_translateFrom.TS != null)
			{
				temp.TS = TranslatorHelper.TranslateTimeStampToBusiness(_translateFrom.TS);
			}
			if (_translateFrom.CreatedBy != null)
			{
				temp.CreatedBy = _translateFrom.CreatedBy;
			}
			else
			{
			temp.CreatedBy = String.Empty;
			}
			if (_translateFrom.CreatedDt != null)
			{
				temp.CreatedDt = _translateFrom.CreatedDt;
			}
			else
			{
			temp.CreatedDt = Convert.ToDateTime(@"01\01\1753");
			}
			if (_translateFrom.ModifiedBy != null)
			{
				temp.ModifiedBy = _translateFrom.ModifiedBy;
			}
			else
			{
			temp.ModifiedBy = String.Empty;
			}
			if (_translateFrom.ModifiedDt != null)
			{
				temp.ModifiedDt = _translateFrom.ModifiedDt;
			}
			else
			{
			temp.ModifiedDt = Convert.ToDateTime(@"01\01\1753");
			}
			
			
			}
			return temp;
			
		}
		
		public IDomainName_ui TranslateFromBusinessLayer(IDomainName_biz _translateFrom)
        {
            IDomainName_ui temp = new DomainName_ui();
		
			if(_translateFrom != null)
			{
			    temp.Action = _translateFrom.Action;
                temp.Caller = _translateFrom.Caller;
                temp.Role = _translateFrom.Role;
                temp.PageSize = _translateFrom.PageSize;
                temp.PageNumber = _translateFrom.PageNumber;
                temp.SortColumn = _translateFrom.SortColumn;
                temp.SortType = _translateFrom.SortType;
                temp.TotalRows = _translateFrom.TotalRows;
			if (_translateFrom.DomainNameID != null)
			{
				temp.DomainNameID = _translateFrom.DomainNameID;
			}
			else
			{
			temp.DomainNameID = -1;
			}
			if (_translateFrom.EmailDomain != null)
			{
				temp.EmailDomain = _translateFrom.EmailDomain;
			}
			else
			{
			temp.EmailDomain = String.Empty;
			}
			if (_translateFrom.DomainDeny != null)
			{
				temp.DomainDeny = _translateFrom.DomainDeny;
			}
			else
			{
			temp.DomainDeny = false;
			}
			if (_translateFrom.TS != null)
			{
				temp.TS = TranslatorHelper.TranslateTimeStampFromBusiness(_translateFrom.TS);
			}
			if (_translateFrom.CreatedBy != null)
			{
				temp.CreatedBy = _translateFrom.CreatedBy;
			}
			else
			{
			temp.CreatedBy = String.Empty;
			}
			if (_translateFrom.CreatedDt != null)
			{
				temp.CreatedDt = _translateFrom.CreatedDt;
			}
			else
			{
			temp.CreatedDt = Convert.ToDateTime(@"01\01\1753");
			}
			if (_translateFrom.ModifiedBy != null)
			{
				temp.ModifiedBy = _translateFrom.ModifiedBy;
			}
			else
			{
			temp.ModifiedBy = String.Empty;
			}
			if (_translateFrom.ModifiedDt != null)
			{
				temp.ModifiedDt = _translateFrom.ModifiedDt;
			}
			else
			{
			temp.ModifiedDt = Convert.ToDateTime(@"01\01\1753");
			}
			
			
			}
			return temp;
			
		}
	
	
	}


}