using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using T2.WebSecurity.ASPMVC.Entity;
using T2.WebSecurity.ASPMVC.Entity.Interface;
using T2.WebSecurity.Business.Entities.Interfaces;
using T2.WebSecurity.Business.Entities;
using T2.WebSecurity.ASPMVC.Entity.Translators;

//--Change Management Control - UserProfileData ASPMVC Entity Translator  --**********************
//--Created By: James Rooks
//--Description: UserProfileData Translator
//--Created Date: 02/05/2013 18:24:30
//--*************************************************************
namespace T2.WebSecurity.ASPMVC.Entity.Translators
{
	public class UserProfileDataUITranslator 
	{
		public IUserProfileData_biz TranslateToBusinessLayer(IUserProfileData_ui _translateFrom)
        {
            IUserProfileData_biz temp = new UserProfileData_biz();
		
			if(_translateFrom != null)
			{
			    temp.Action = _translateFrom.Action;
                temp.Caller = _translateFrom.Caller;
                temp.Role = _translateFrom.Role;
                temp.PageSize = _translateFrom.PageSize;
                temp.PageNumber = _translateFrom.PageNumber;
                temp.SortColumn = _translateFrom.SortColumn;
                temp.SortType = _translateFrom.SortType;
                temp.TotalRows = _translateFrom.TotalRows;
			if (_translateFrom.UserProfileDataID != null)
			{
				temp.UserProfileDataID = _translateFrom.UserProfileDataID;
			}
			else
			{
			temp.UserProfileDataID = -1;
			}
			if (_translateFrom.UPDName != null)
			{
				temp.UPDName = _translateFrom.UPDName;
			}
			else
			{
			temp.UPDName = String.Empty;
			}
			if (_translateFrom.UPDValue != null)
			{
				temp.UPDValue = _translateFrom.UPDValue;
			}
			else
			{
			temp.UPDValue = String.Empty;
			}
			if (_translateFrom.TS != null)
			{
				temp.TS = TranslatorHelper.TranslateTimeStampToBusiness(_translateFrom.TS);
			}
			if (_translateFrom.CreatedBy != null)
			{
				temp.CreatedBy = _translateFrom.CreatedBy;
			}
			else
			{
			temp.CreatedBy = String.Empty;
			}
			if (_translateFrom.CreatedDt != null)
			{
				temp.CreatedDt = _translateFrom.CreatedDt;
			}
			else
			{
			temp.CreatedDt = Convert.ToDateTime(@"01\01\1753");
			}
			if (_translateFrom.ModifiedBy != null)
			{
				temp.ModifiedBy = _translateFrom.ModifiedBy;
			}
			else
			{
			temp.ModifiedBy = String.Empty;
			}
			if (_translateFrom.ModifiedDt != null)
			{
				temp.ModifiedDt = _translateFrom.ModifiedDt;
			}
			else
			{
			temp.ModifiedDt = Convert.ToDateTime(@"01\01\1753");
			}
			if (_translateFrom.UserId != null)
			{
				temp.UserId = _translateFrom.UserId;
			}
			else
			{
			temp.UserId = -1;
			}
			UserProfileUITranslator UserProfileUITranslator = new UserProfileUITranslator();
			temp.UserProfile =UserProfileUITranslator.TranslateToBusinessLayer(_translateFrom.UserProfile);
			
			
			}
			return temp;
			
		}
		
		public IUserProfileData_ui TranslateFromBusinessLayer(IUserProfileData_biz _translateFrom)
        {
            IUserProfileData_ui temp = new UserProfileData_ui();
		
			if(_translateFrom != null)
			{
			    temp.Action = _translateFrom.Action;
                temp.Caller = _translateFrom.Caller;
                temp.Role = _translateFrom.Role;
                temp.PageSize = _translateFrom.PageSize;
                temp.PageNumber = _translateFrom.PageNumber;
                temp.SortColumn = _translateFrom.SortColumn;
                temp.SortType = _translateFrom.SortType;
                temp.TotalRows = _translateFrom.TotalRows;
			if (_translateFrom.UserProfileDataID != null)
			{
				temp.UserProfileDataID = _translateFrom.UserProfileDataID;
			}
			else
			{
			temp.UserProfileDataID = -1;
			}
			if (_translateFrom.UPDName != null)
			{
				temp.UPDName = _translateFrom.UPDName;
			}
			else
			{
			temp.UPDName = String.Empty;
			}
			if (_translateFrom.UPDValue != null)
			{
				temp.UPDValue = _translateFrom.UPDValue;
			}
			else
			{
			temp.UPDValue = String.Empty;
			}
			if (_translateFrom.TS != null)
			{
				temp.TS = TranslatorHelper.TranslateTimeStampFromBusiness(_translateFrom.TS);
			}
			if (_translateFrom.CreatedBy != null)
			{
				temp.CreatedBy = _translateFrom.CreatedBy;
			}
			else
			{
			temp.CreatedBy = String.Empty;
			}
			if (_translateFrom.CreatedDt != null)
			{
				temp.CreatedDt = _translateFrom.CreatedDt;
			}
			else
			{
			temp.CreatedDt = Convert.ToDateTime(@"01\01\1753");
			}
			if (_translateFrom.ModifiedBy != null)
			{
				temp.ModifiedBy = _translateFrom.ModifiedBy;
			}
			else
			{
			temp.ModifiedBy = String.Empty;
			}
			if (_translateFrom.ModifiedDt != null)
			{
				temp.ModifiedDt = _translateFrom.ModifiedDt;
			}
			else
			{
			temp.ModifiedDt = Convert.ToDateTime(@"01\01\1753");
			}
			if (_translateFrom.UserId != null)
			{
				temp.UserId = _translateFrom.UserId;
			}
			else
			{
			temp.UserId = -1;
			}
			UserProfileUITranslator UserProfileUITranslator = new UserProfileUITranslator();
			temp.UserProfile =UserProfileUITranslator.TranslateFromBusinessLayer(_translateFrom.UserProfile);
			
			
			}
			return temp;
			
		}
	
	
	}


}