using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using T2.WebSecurity.ASPMVC.Entity.Interface;
using T2.WebSecurity.ASPMVC.Entity;
using T2.WebSecurity.Business.Entities;
using T2.WebSecurity.Business.Entities.Interfaces;
using T2.WebSecurity.ASPMVC.Entity.Search;
using T2.WebSecurity.ASPMVC.Entity.Search.Interface;
using T2.WebSecurity.Business.Entities.Search;
using T2.WebSecurity.Business.Entities.Search.Interfaces;
using T2.WebSecurity.ASPMVC.Entity.Translators;
using T2.WebSecurity.ASPMVC.Entity.Translators.Search;


namespace T2.WebSecurity.ASPMVC.ViewModel
{

	public class DomainNameViewModel
	{
		Business.BusinessService bs = new Business.BusinessService();
		public DomainNameViewModel(bool loadParent)
		{
		if (loadParent)
			{
			}
		}
		
		private String m_header;
		public String Header
        {
            get
            {
                return "Domain Name";
            }
			
			set
            {
                m_header = value;
            }
        }
		
		private String m_title;
		public String Title
        {
            get
            {
                return "Domain Name";
            }
			
			set
            {
                m_title = value;
            }
        }
		
		private IDomainName_ui m_model;
		public IDomainName_ui Model
		{
			get
			{
				return m_model;
			}
			set
			{
				m_model = value;
			}
		}
				
        
		
		public void LoadModel(IDomainName_ui param)
        {
            DomainNameUITranslator trans = new DomainNameUITranslator();
            IDomainName_biz bizParam = trans.TranslateToBusinessLayer(param);
            List<IDomainName_biz> tempRetVal = bs.DomainNameController_Get(bizParam, true, true);
            IDomainName_ui retVal = new DomainName_ui();
            if (tempRetVal != null && tempRetVal.Count > 0)
            {
                retVal = trans.TranslateFromBusinessLayer(tempRetVal.First());
            }

            m_model = retVal;

        }

        public Int32 Set(IDomainName_ui param)
        {
            DomainNameUITranslator trans = new DomainNameUITranslator();
            IDomainName_biz bizParam = trans.TranslateToBusinessLayer(param);
            IDictionary<string,int> r = bs.DomainNameController_Set(bizParam);
            var ret = r.ToList().Select(s => new { Key = s.Key, Value = s.Value });
            Int32 retVal = ret.Where(z => z.Key == "Return_Value").Select(m => m.Value).FirstOrDefault();
			return retVal;
        }

       

        public List<IDomainName_ui> SearchList(IDomainNameSearch_ui param)
        {
            DomainNameUISearchTranslator transSearch = new DomainNameUISearchTranslator();
            IDomainNameSearch_biz bizParam = transSearch.TranslateToBusinessLayer(param);
            List<IDomainName_biz> retValBiz = bs.DomainNameController_Search(bizParam, true, true);
            List<IDomainName_ui> retVal = new List<IDomainName_ui>();
            DomainNameUITranslator trans = new DomainNameUITranslator();
            foreach (IDomainName_biz item in retValBiz)
            {
                IDomainName_ui temp = trans.TranslateFromBusinessLayer(item);
                retVal.Add(temp);
            }

            
            return retVal;

        }

        

        public List<IDomainName_ui> ModelList(IDomainName_ui param)
        {

            DomainNameUITranslator trans = new DomainNameUITranslator();
            IDomainName_biz bizParam = trans.TranslateToBusinessLayer(param);
            List<IDomainName_biz> retValBiz = bs.DomainNameController_Get(bizParam, true, true);
            List<IDomainName_ui> retVal = new List<IDomainName_ui>();
            foreach (IDomainName_biz item in retValBiz)
            {
                IDomainName_ui temp = trans.TranslateFromBusinessLayer(item);
                retVal.Add(temp);
            }

            
            return retVal;

        }
		
	}
}
