using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using T2.WebSecurity.ASPMVC.Entity.Interface;
using T2.WebSecurity.ASPMVC.Entity;
using T2.WebSecurity.Business.Entities;
using T2.WebSecurity.Business.Entities.Interfaces;
using T2.WebSecurity.ASPMVC.Entity.Search;
using T2.WebSecurity.ASPMVC.Entity.Search.Interface;
using T2.WebSecurity.Business.Entities.Search;
using T2.WebSecurity.Business.Entities.Search.Interfaces;
using T2.WebSecurity.ASPMVC.Entity.Translators;
using T2.WebSecurity.ASPMVC.Entity.Translators.Search;


namespace T2.WebSecurity.ASPMVC.ViewModel
{

	public class MembershipViewModel
	{
		Business.BusinessService bs = new Business.BusinessService();
		public MembershipViewModel(bool loadParent)
		{
		if (loadParent)
			{
				this.LoadUserProfileList();
				this.LoadPasswordQuestionList();
			}
		}
		
		private String m_header;
		public String Header
        {
            get
            {
                return "Membership";
            }
			
			set
            {
                m_header = value;
            }
        }
		
		private String m_title;
		public String Title
        {
            get
            {
                return "Membership";
            }
			
			set
            {
                m_title = value;
            }
        }
		
		private IMembership_ui m_model;
		public IMembership_ui Model
		{
			get
			{
				return m_model;
			}
			set
			{
				m_model = value;
			}
		}
		private List<IUserProfile_ui> m_userprofilelist;
		public List<IUserProfile_ui> UserProfile_List
		{
			get
			{
				return m_userprofilelist;
			}
			set
			{
				m_userprofilelist = value;
			}
		}

		private List<IPasswordQuestion_ui> m_passwordquestionlist;
		public List<IPasswordQuestion_ui> PasswordQuestion_List
		{
			get
			{
				return m_passwordquestionlist;
			}
			set
			{
				m_passwordquestionlist = value;
			}
		}

		 private void LoadUserProfileList()
		{
			IUserProfile_biz param = new UserProfile_biz();
			param.Action = "GetAll";
			param.PageNumber = 1;
			param.PageSize = 20;
			param.SortColumn = "UserId";
			param.SortType = "desc";
			param.TotalRows = -1;
			List<IUserProfile_biz> retVal = bs.UserProfileController_Get(param, true, true);
			List<IUserProfile_ui> LoadRetVal = new List<IUserProfile_ui>();
			UserProfileUITranslator trans = new UserProfileUITranslator();
			foreach (IUserProfile_biz item in retVal)
			{
				IUserProfile_ui temp = new UserProfile_ui();
				temp = trans.TranslateFromBusinessLayer(item);
				LoadRetVal.Add(temp);
			}
			m_userprofilelist = LoadRetVal;
		}

		 private void LoadPasswordQuestionList()
		{
			IPasswordQuestion_biz param = new PasswordQuestion_biz();
			param.Action = "GetAll";
			param.PageNumber = 1;
			param.PageSize = 20;
			param.SortColumn = "PasswordQuestionID";
			param.SortType = "desc";
			param.TotalRows = -1;
			List<IPasswordQuestion_biz> retVal = bs.PasswordQuestionController_Get(param, true, true);
			List<IPasswordQuestion_ui> LoadRetVal = new List<IPasswordQuestion_ui>();
			PasswordQuestionUITranslator trans = new PasswordQuestionUITranslator();
			foreach (IPasswordQuestion_biz item in retVal)
			{
				IPasswordQuestion_ui temp = new PasswordQuestion_ui();
				temp = trans.TranslateFromBusinessLayer(item);
				LoadRetVal.Add(temp);
			}
			m_passwordquestionlist = LoadRetVal;
		}


        
		
		public void LoadModel(IMembership_ui param)
        {
            MembershipUITranslator trans = new MembershipUITranslator();
            IMembership_biz bizParam = trans.TranslateToBusinessLayer(param);
            List<IMembership_biz> tempRetVal = bs.MembershipController_Get(bizParam, true, true);
            IMembership_ui retVal = new Membership_ui();
            if (tempRetVal != null && tempRetVal.Count > 0)
            {
                retVal = trans.TranslateFromBusinessLayer(tempRetVal.First());
            }

            m_model = retVal;

        }

        public Int32 Set(IMembership_ui param)
        {
            MembershipUITranslator trans = new MembershipUITranslator();
            IMembership_biz bizParam = trans.TranslateToBusinessLayer(param);
            IDictionary<string,int> r = bs.MembershipController_Set(bizParam);
            var ret = r.ToList().Select(s => new { Key = s.Key, Value = s.Value });
            Int32 retVal = ret.Where(z => z.Key == "Return_Value").Select(m => m.Value).FirstOrDefault();
			return retVal;
        }

       

        public List<IMembership_ui> SearchList(IMembershipSearch_ui param)
        {
            MembershipUISearchTranslator transSearch = new MembershipUISearchTranslator();
            IMembershipSearch_biz bizParam = transSearch.TranslateToBusinessLayer(param);
            List<IMembership_biz> retValBiz = bs.MembershipController_Search(bizParam, true, true);
            List<IMembership_ui> retVal = new List<IMembership_ui>();
            MembershipUITranslator trans = new MembershipUITranslator();
            foreach (IMembership_biz item in retValBiz)
            {
                IMembership_ui temp = trans.TranslateFromBusinessLayer(item);
                retVal.Add(temp);
            }

            
            return retVal;

        }

        

        public List<IMembership_ui> ModelList(IMembership_ui param)
        {

            MembershipUITranslator trans = new MembershipUITranslator();
            IMembership_biz bizParam = trans.TranslateToBusinessLayer(param);
            List<IMembership_biz> retValBiz = bs.MembershipController_Get(bizParam, true, true);
            List<IMembership_ui> retVal = new List<IMembership_ui>();
            foreach (IMembership_biz item in retValBiz)
            {
                IMembership_ui temp = trans.TranslateFromBusinessLayer(item);
                retVal.Add(temp);
            }

            
            return retVal;

        }
		
	}
}
