using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using T2.WebSecurity.ASPMVC.Entity.Interface;
using T2.WebSecurity.ASPMVC.Entity;
using T2.WebSecurity.Business.Entities;
using T2.WebSecurity.Business.Entities.Interfaces;
using T2.WebSecurity.ASPMVC.Entity.Search;
using T2.WebSecurity.ASPMVC.Entity.Search.Interface;
using T2.WebSecurity.Business.Entities.Search;
using T2.WebSecurity.Business.Entities.Search.Interfaces;
using T2.WebSecurity.ASPMVC.Entity.Translators;
using T2.WebSecurity.ASPMVC.Entity.Translators.Search;


namespace T2.WebSecurity.ASPMVC.ViewModel
{

	public class UserProfileDataViewModel
	{
		Business.BusinessService bs = new Business.BusinessService();
		public UserProfileDataViewModel(bool loadParent)
		{
		if (loadParent)
			{
				this.LoadUserProfileList();
			}
		}
		
		private String m_header;
		public String Header
        {
            get
            {
                return "User Profile Data";
            }
			
			set
            {
                m_header = value;
            }
        }
		
		private String m_title;
		public String Title
        {
            get
            {
                return "User Profile Data";
            }
			
			set
            {
                m_title = value;
            }
        }
		
		private IUserProfileData_ui m_model;
		public IUserProfileData_ui Model
		{
			get
			{
				return m_model;
			}
			set
			{
				m_model = value;
			}
		}
		private List<IUserProfile_ui> m_userprofilelist;
		public List<IUserProfile_ui> UserProfile_List
		{
			get
			{
				return m_userprofilelist;
			}
			set
			{
				m_userprofilelist = value;
			}
		}

		 private void LoadUserProfileList()
		{
			IUserProfile_biz param = new UserProfile_biz();
			param.Action = "GetAll";
			param.PageNumber = 1;
			param.PageSize = 20;
			param.SortColumn = "UserId";
			param.SortType = "desc";
			param.TotalRows = -1;
			List<IUserProfile_biz> retVal = bs.UserProfileController_Get(param, true, true);
			List<IUserProfile_ui> LoadRetVal = new List<IUserProfile_ui>();
			UserProfileUITranslator trans = new UserProfileUITranslator();
			foreach (IUserProfile_biz item in retVal)
			{
				IUserProfile_ui temp = new UserProfile_ui();
				temp = trans.TranslateFromBusinessLayer(item);
				LoadRetVal.Add(temp);
			}
			m_userprofilelist = LoadRetVal;
		}


        
		
		public void LoadModel(IUserProfileData_ui param)
        {
            UserProfileDataUITranslator trans = new UserProfileDataUITranslator();
            IUserProfileData_biz bizParam = trans.TranslateToBusinessLayer(param);
            List<IUserProfileData_biz> tempRetVal = bs.UserProfileDataController_Get(bizParam, true, true);
            IUserProfileData_ui retVal = new UserProfileData_ui();
            if (tempRetVal != null && tempRetVal.Count > 0)
            {
                retVal = trans.TranslateFromBusinessLayer(tempRetVal.First());
            }

            m_model = retVal;

        }

        public Int32 Set(IUserProfileData_ui param)
        {
            UserProfileDataUITranslator trans = new UserProfileDataUITranslator();
            IUserProfileData_biz bizParam = trans.TranslateToBusinessLayer(param);
            IDictionary<string,int> r = bs.UserProfileDataController_Set(bizParam);
            var ret = r.ToList().Select(s => new { Key = s.Key, Value = s.Value });
            Int32 retVal = ret.Where(z => z.Key == "Return_Value").Select(m => m.Value).FirstOrDefault();
			return retVal;
        }

       

        public List<IUserProfileData_ui> SearchList(IUserProfileDataSearch_ui param)
        {
            UserProfileDataUISearchTranslator transSearch = new UserProfileDataUISearchTranslator();
            IUserProfileDataSearch_biz bizParam = transSearch.TranslateToBusinessLayer(param);
            List<IUserProfileData_biz> retValBiz = bs.UserProfileDataController_Search(bizParam, true, true);
            List<IUserProfileData_ui> retVal = new List<IUserProfileData_ui>();
            UserProfileDataUITranslator trans = new UserProfileDataUITranslator();
            foreach (IUserProfileData_biz item in retValBiz)
            {
                IUserProfileData_ui temp = trans.TranslateFromBusinessLayer(item);
                retVal.Add(temp);
            }

            
            return retVal;

        }

        

        public List<IUserProfileData_ui> ModelList(IUserProfileData_ui param)
        {

            UserProfileDataUITranslator trans = new UserProfileDataUITranslator();
            IUserProfileData_biz bizParam = trans.TranslateToBusinessLayer(param);
            List<IUserProfileData_biz> retValBiz = bs.UserProfileDataController_Get(bizParam, true, true);
            List<IUserProfileData_ui> retVal = new List<IUserProfileData_ui>();
            foreach (IUserProfileData_biz item in retValBiz)
            {
                IUserProfileData_ui temp = trans.TranslateFromBusinessLayer(item);
                retVal.Add(temp);
            }

            
            return retVal;

        }
		
	}
}
